/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WFREESTREAM_H
#define WFREESTREAM_H

#include "flow.h"
#include "wGroup.h"
#include "wFct1.h"

namespace flow
{

/**
 * @brief Manage freestream (Freestream) boundary condtion
 * @authors Adrien Crovato
 */
class FLOW_API Freestream : public tbox::Group
{
public:
#ifndef SWIG
    tbox::Fct1 &f; ///< vector valued function to compute flux
#endif
    Freestream(std::shared_ptr<tbox::MshData> _msh, int no, tbox::Fct1 &_f);
    Freestream(std::shared_ptr<tbox::MshData> _msh, std::string const &name, tbox::Fct1 &_f);
    virtual ~Freestream() { std::cout << "~Freestream()\n"; }

#ifndef SWIG
    virtual void write(std::ostream &out) const override;
#endif
};

} // namespace flow

#endif //WFREESTREAM_H
