#!/usr/bin/env python
# -*- coding: latin-1; -*-

from mrstlnos.eigenvalues import *
import os
import fwk

from scipy.sparse import eye

def main():
    file_dir = os.path.dirname(__file__)
    work_dir = os.getcwd()

    N = 200
    gamma_min_exp = -2
    gamma_max_exp = 10

    gammas = np.logspace(gamma_min_exp, gamma_max_exp, N, endpoint=True)
    
    input_file_dir = file_dir + '/../../workspace/mrstlnos_CMAME_tests_plate_MC_NO_EP/1/'
    
    filename_K = input_file_dir  + '0/A_mm_after_bc.txt'
    filename_GT = input_file_dir  + '0/B_mm.txt'
    
    K = read_mm(filename_K)
    GT = read_mm(filename_GT)
    G = GT.transpose()
    
    for i in range(0,N):
      timers = fwk.Timers()
      
      Q = K + gammas[i] * G * GT
      
      timers['Compute R'].start()
      R = approx_Schur_complement(Q,G,GT)
      timers['Compute R'].stop()
      
      print timers
      
      timers['Compute the inverse of Q'].start()
      invQG = compute_inv_on_image(Q,G)
      timers['Compute the inverse of Q'].stop()
      
      print timers
      
      timers['Compute the eigenvalues'].start()
      v = eigenvalues_SR(invQG,G,GT,R,True)
      timers['Compute the eigenvalues'].stop()
      
      print timers
      
      timers['Write the eigenvalues'].start()
      write_eigenvalues(v,work_dir+'/eigenvalues_direct_direct_'+ str(i) +'.txt')
      timers['Write the eigenvalues'].stop()

      f = open('timers_'+ str(i) +'.txt', 'w')
      print >>f, timers
      f.closed
if __name__ == "__main__":
    main()
