#!/bin/bash
# Submission script for Blake
#SBATCH --job-name=GEMV_update
#SBATCH --time=47:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p blake
#
#SBATCH --comment=test
#SBATCH --output=/ascldap/users/knliege/dev/waves_all/blake/waves/workspace/GEMV_update/GEMV_update.%j.out

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=48
export KMP_PLACE_THREADS=24c,2t
export KMP_AFFINITY=compact,verbose

export N_NUMA=2
export THREADS_PER_NUMA=24

export n=1
export N=500
export k_min=100
export k_max=101
export d_k=1

export tiles_per_thread=10
export per_tile_min=100
per_tile_max=101
export d_per_tile=1

export n_tile=$(($OMP_NUM_THREADS*$tiles_per_thread))

export layout=-l

cd /ascldap/users/knliege/dev/waves_all/blake/waves/workspace/
if [ ! -d "GEMV_update" ]; then
  mkdir GEMV_update
fi

cd GEMV_update

per_tile=$per_tile_min

cp -R ../../../waves/mrstlnos/GEMV_update GEMV_update_files_${SLURM_JOBID}
cp ../../../wavesB/mrstlnos/GEMV_update/CMakeFiles/GEMV_update.dir/MP_VECTOR_GEMV.cpp.optrpt GEMV_update_files_${SLURM_JOBID}/MP_VECTOR_GEMV.cpp.optrpt
cp ../../../wavesB/bin/GEMV_update GEMV_update_${SLURM_JOBID}

m=$(($per_tile*$n_tile))
export test_name=update_u_1_all_s_${SLURM_JOBID}
amplxe-cl -collect hotspots -collect memory-access -collect hotspots -call-stack-mode all -analyze-system ./GEMV_update_${SLURM_JOBID} --kokkos-threads=$THREADS_PER_NUMA --kokkos-numa=$N_NUMA $layout -f $test_name -m $m -n $n -N $N -k_min $k_min -k_max $k_max -d_k $d_k -algo 3 -per_tile $per_tile -s 8 -u 1
