#!/bin/bash
# Submission script for Bowman
#SBATCH --job-name=GEMV_update
#SBATCH --time=47:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p knl-delta
#
#SBATCH --comment=test
#SBATCH --output=workspace/GEMV_update/GEMV_update_256.%j.out

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=256

export KMP_HW_SUBSET=64c,4t
export KMP_AFFINITY=balanced


export n=1
export N=50
export k_min=100
export k_max=101
export d_k=1

#m=2621440
#n_c=( 1, 2, 4, 5, 8, 10, 16, 20, 32, 40, 64, 80, 128, 160, 256, 320, 512, 640, 1024, 1280, 2048, 2560, 5120, 10240)

m=655360
n_c=( 1, 2, 4, 5, 8, 10, 16, 20, 32, 40, 64, 80, 128, 160, 256, 320, 512, 640, 1280, 2560)

#m=327680
#n_c=( 1, 2, 4, 5, 8, 10, 16, 20, 32, 40, 64, 80, 128, 160, 256, 320, 640, 1280)

export layout=-l

cd /ascldap/users/knliege/dev/waves_all/bowman/waves/workspace/
if [ ! -d "GEMV_update" ]; then
  mkdir GEMV_update
fi

cd GEMV_update

cp -R ../../../waves/mrstlnos/GEMV_update GEMV_update_files_${SLURM_JOBID}
cp ../../../wavesB/mrstlnos/GEMV_update/CMakeFiles/GEMV_update.dir/MP_VECTOR_GEMV.cpp.optrpt GEMV_update_files_${SLURM_JOBID}/MP_VECTOR_GEMV.cpp.optrpt
cp ../../../wavesB/bin/GEMV_update GEMV_update_${SLURM_JOBID}

export test_name=update_fixed_${SLURM_JOBID}_256

for per_tile in "${n_c[@]}"
do
  ./GEMV_update_${SLURM_JOBID} --kokkos-threads=$OMP_NUM_THREADS $layout -f $test_name -m $m -n $n -N $N -k_min $k_min -k_max $k_max -d_k $d_k -algo 2 -per_tile $per_tile -s 8 -u 1
done
