#!/bin/bash
# Submission script for Bowman
#SBATCH --job-name=GEMV_update
#SBATCH --time=47:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p knl-delta
#
#SBATCH --comment=test
#SBATCH --output=workspace/GEMV_update/GEMV_update_128.%j.out

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=128

export KMP_HW_SUBSET=64c,4t
export KMP_AFFINITY=balanced


export n=1
export N=50
export k_min=100
export k_max=101
export d_k=1

export tiles_per_thread=10
export per_tile_min=10
per_tile_max=1025
export d_per_tile=1

export n_tile=$(($OMP_NUM_THREADS*$tiles_per_thread))

export layout=-l

cd /ascldap/users/knliege/dev/waves_all/bowman/waves/workspace/
if [ ! -d "GEMV_update" ]; then
  mkdir GEMV_update
fi

cd GEMV_update

per_tile=$per_tile_min

cp -R ../../../waves/mrstlnos/GEMV_update GEMV_update_files_${SLURM_JOBID}
cp ../../../wavesB/mrstlnos/GEMV_update/CMakeFiles/GEMV_update.dir/MP_VECTOR_GEMV.cpp.optrpt GEMV_update_files_${SLURM_JOBID}/MP_VECTOR_GEMV.cpp.optrpt
cp ../../../wavesB/bin/GEMV_update GEMV_update_${SLURM_JOBID}

export test_name=update_linear_${SLURM_JOBID}_128

while [ $per_tile -lt $per_tile_max ]
do
  m=$(($per_tile*$n_tile))
  ./GEMV_update_${SLURM_JOBID} --kokkos-threads=$OMP_NUM_THREADS $layout -flush -f $test_name -m $m -n $n -N $N -k_min $k_min -k_max $k_max -d_k $d_k -algo 2 -per_tile $per_tile -s 8 -u 1
  per_tile=`expr $per_tile + $d_per_tile`
done
