Macro Weld_bolt
  new_weld_line_loop = newreg;
  Curve Loop(new_weld_line_loop) = curves_id_1[];
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 0.026} {
    Surface{new_weld_line_loop};
  };
  new_volume_1 = num[1];
  num[] = Extrude {0, 0, -0.012} {
    Surface{new_weld_line_loop};
  };
  new_volume_2 = num[1];
  new_weld_line_loop = newreg;
  Curve Loop(new_weld_line_loop) = curves_id_2[];
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, 0.002} {
    Surface{new_weld_line_loop};
  };
  new_volume_3 = num[1];
  new_weld_line_loop = newreg;
  Curve Loop(new_weld_line_loop) = curves_id_3[];
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};
  num[] = Extrude {0, 0, -0.006} {
    Surface{new_weld_line_loop};
  };
  new_volume_4 = num[1];
  num[] = BooleanUnion{ Volume{volume_id_1}; Delete; }{ Volume{volume_id_2}; Volume{volume_id_3}; Volume{volume_id_4}; Volume{volume_id_5}; Volume{volume_id_6}; Volume{volume_id_7}; Volume{volume_id_8}; Volume{volume_id_9}; Volume{new_volume_1}; Volume{new_volume_2}; Volume{new_volume_3}; Volume{new_volume_4}; Delete; };
  new_volume_1 = num[0];
Return

Macro Weld_tube
  c1[] = Point{pipe_p1};
  c2[] = Point{pipe_p2};
  center1[] = {(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2};
  pipe_radius = Sqrt((c1[0]-center1[0])^2+(c1[1]-center1[1])^2+(c1[2]-center1[2])^2);

  c1[] = Point{weld_p1};
  c2[] = Point{weld_p5};
  center1[] = {(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2};
  weld_radius = Sqrt((c1[0]-center1[0])^2+(c1[1]-center1[1])^2+(c1[2]-center1[2])^2);

  new_weld_p1 = newp;
  Point(new_weld_p1) = {(pipe_radius/weld_radius)*(c1[0]-center1[0])+center1[0],(pipe_radius/weld_radius)*(c1[1]-center1[1])+center1[1],(pipe_radius/weld_radius)*(c1[2]-center1[2])+center1[2]};
  new_weld_line1 = newreg; Line(new_weld_line1) = {new_weld_p1, weld_p2};
  new_weld_line2 = newreg; Line(new_weld_line2) = {weld_p2, weld_p3};
  new_weld_line3 = newreg; Line(new_weld_line3) = {weld_p3, weld_p4};
  new_weld_line4 = newreg; Line(new_weld_line4) = {weld_p4, new_weld_p1};

  new_weld_line_loop = newreg;  Line Loop(new_weld_line_loop) = {new_weld_line1,new_weld_line2,new_weld_line3,new_weld_line4};
  Plane Surface(new_weld_line_loop) = {new_weld_line_loop};

  c1[]=Point{weld_p3};
  c2[]=Point{weld_p4};

  Extrude {{c2[0]-c1[0],c2[1]-c1[1],c2[2]-c1[2]}, {center1[0], center1[1], center1[2]}, Pi} {
    Surface{new_weld_line_loop};
  }
  Extrude {{c2[0]-c1[0],c2[1]-c1[1],c2[2]-c1[2]}, {center1[0], center1[1], center1[2]}, -Pi} {
    Surface{new_weld_line_loop};
  }
Return

Macro Compute_cross_and_theta
  norm_1 = Sqrt(vec_1[0]^2+vec_1[1]^2+vec_1[2]^2);
  norm_2 = Sqrt(vec_2[0]^2+vec_2[1]^2+vec_2[2]^2);

  cross[] = {vec_1[1]*vec_2[2]-vec_1[2]*vec_2[1],vec_1[2]*vec_2[0]-vec_1[0]*vec_2[2],vec_1[0]*vec_2[1]-vec_1[1]*vec_2[0]};
  norm_cross = Sqrt(cross[0]^2+cross[1]^2+cross[2]^2);

  dot = vec_1[0]*vec_2[0] + vec_1[1]*vec_2[1] + vec_1[2]*vec_2[2];

  theta = Acos(dot/(norm_1*norm_2));
Return

Macro Rotate_Axis
  allPoints[] = Point "*" ;
  allLines[] = Line "*" ;
  allSurfaces[] = Surface "*";
  allVolumes[] = Volume "*";
  c1[] = Point{point_OX_1};
  c2[] = Point{point_OX_2};
  OX[] = {c2[0]-c1[0],c2[1]-c1[1],c2[2]-c1[2]};
  vec_1[] = OX[];
  vec_2[] = {1,0,0};

  Call Compute_cross_and_theta;

  Rotate {{cross[0],cross[1],cross[2]}, {0, 0, 0}, theta} { Point{ allPoints[] } ; Line{ allLines[] } ; Surface{ allSurfaces[] } ; Volume{allVolumes[] } ; }

  allPoints[] = Point "*" ;
  allLines[] = Line "*" ;
  allSurfaces[] = Surface "*";
  allVolumes[] = Volume "*";
  c3[] = Point{point_OY_1};
  c4[] = Point{point_OY_2};
  OY[] = {c4[0]-c3[0],c4[1]-c3[1],c4[2]-c3[2]};
  vec_1[] = OY[];
  vec_2[] = {0,1,0};

  Call Compute_cross_and_theta;
  Rotate {{cross[0],cross[1],cross[2]}, {0, 0, 0}, theta} { Point{ allPoints[] } ; Line{ allLines[] } ; Surface{ allSurfaces[] } ; Volume{allVolumes[] } ; }

Return

Macro Translate_Axis
  allPoints[] = Point "*" ;
  allLines[] = Line "*" ;
  allSurfaces[] = Surface "*";
  allVolumes[] = Volume "*";
  c1[] = Point{point_OO};
  Translate {-c1[0],-c1[1],-c1[2]} { Point{ allPoints[] } ; Line{ allLines[] } ; Surface{ allSurfaces[] } ; Volume{allVolumes[] } ; }
  allPoints[] = Point "*" ;
  allLines[] = Line "*" ;
  allSurfaces[] = Surface "*";
  allVolumes[] = Volume "*";
Return

Macro Contact_disk
  c1[] = Point{point_disk_R_1};
  c2[] = Point{point_disk_R_2};

  center[] = {(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2};

  R = Sqrt((c1[0]-center[0])^2+(c1[1]-center[1])^2+(c1[2]-center[2])^2);

  c1[] = Point{point_surface_disk_1};
  c2[] = Point{point_surface_disk_2};

  new_disk = newreg;
  Disk(new_disk) = {(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2, R, R};

  Printf("c1 (%g,%g,%g)",c1[0],c1[1],c1[2]);
  Printf("c2 (%g,%g,%g)",c2[0],c2[1],c2[2]);
  Printf("Center (%g,%g,%g) radius %g",(c1[0]+c2[0])/2, (c1[1]+c2[1])/2, (c1[2]+c2[2])/2, R) ;

  BooleanFragments{ Surface{new_disk}; Delete; }{ Volume{volume_id}; Delete; }
Return

SetFactory("OpenCASCADE");

v() = ShapeFromFile("mirror_assembly.stp");

Physical Volume("Mirror") = {2};
Physical Volume("Substrate") = {1};
Physical Volume("Washer 1") = {6};
Physical Volume("Washer 2") = {5};
Physical Volume("Washer 3") = {4};

Physical Volume("Pin 1") = {3};
Physical Volume("Pin 2") = {17};
Physical Volume("Pin 3") = {18};

Physical Volume("Shaft 1") = {9};
Physical Volume("Shaft 2") = {8};
Physical Volume("Shaft 3") = {7};

Physical Volume("Spacer 1 part 1") = {13};
Physical Volume("Spacer 2 part 1") = {12};
Physical Volume("Spacer 3 part 1") = {10};

Physical Volume("Spacer 1 part 2") = {15};
Physical Volume("Spacer 2 part 2") = {14};
Physical Volume("Spacer 3 part 2") = {11};

Physical Volume("Holder") = {16,19};

Physical Volume("Nut 1") = {25};
Physical Volume("Nut 2") = {26};
//Physical Volume("Nut 3") = {24,27};

Physical Volume("Holder 2") = {28,29};

//BooleanFragments{ Volume{1,2,7,8,9,24,25,26}; Delete; }{}
BooleanFragments{ Volume{1,2,3,7,8,9,17,18,24,25,26,27}; Delete; }{}

BooleanFragments{ Volume{13,15}; Delete; }{}
BooleanFragments{ Volume{12,14}; Delete; }{}
BooleanFragments{ Volume{10,11}; Delete; }{}


//BooleanFragments{ Volume{54,55,56,57,58,61,62}; Delete; }{}
//BooleanFragments{ Volume{45,48,49,50,51,52,53}; Delete; }{}
//BooleanFragments{ Volume{36,37,38,39,42,43,44}; Delete; }{}

//BooleanFragments{ Volume{16,19}; Delete; }{}


// Fuse pipe 1

weld_p1 = 1477;
weld_p2 = 1478;
weld_p3 = 1473;
weld_p4 = 1471;
weld_p5 = 1475;

pipe_p1 = 898;
pipe_p2 = 900;

Call Weld_tube ;

weld_p1 = 885;
weld_p2 = 886;
weld_p3 = 884;
weld_p4 = 882;
weld_p5 = 887;

pipe_p1 = 907;
pipe_p2 = 908;

Call Weld_tube ;

Recursive Delete { Volume{20,32}; }
Physical Volume("Pipe 1") = {22,66,67,68,69};

// Fuse pipe 2

weld_p1 = 893;
weld_p2 = 894;
weld_p3 = 892;
weld_p4 = 890;
weld_p5 = 895;

pipe_p1 = 932;
pipe_p2 = 931;

Call Weld_tube ;

weld_p1 = 1483;
weld_p2 = 1484;
weld_p3 = 1482;
weld_p4 = 1480;
weld_p5 = 1485;

pipe_p1 = 922;
pipe_p2 = 924;

Call Weld_tube ;
Recursive Delete { Volume{21,33}; }
Physical Volume("Pipe 2") = {23,70,71,72,73};

// Fuse pipe 3

weld_p1 = 1501;
weld_p2 = 1502;
weld_p3 = 1497;
weld_p4 = 1495;
weld_p5 = 1499;

pipe_p1 = 1440;
pipe_p2 = 1439;

Call Weld_tube ;

Recursive Delete { Volume{35}; }
Physical Volume("Pipe 3") = {30,74,75};

// Fuse pipe 4

weld_p1 = 1493;
weld_p2 = 1494;
weld_p3 = 1489;
weld_p4 = 1487;
weld_p5 = 1491;

pipe_p1 = 1456;
pipe_p2 = 1455;

Call Weld_tube ;

Recursive Delete { Volume{34}; }
Physical Volume("Pipe 4") = {31,76,77};

// Realign the axis
point_OX_1 = 1928;
point_OX_2 = 1929;

point_OY_1 = 1925;
point_OY_2 = 1927;

Call Rotate_Axis;

point_OO = 2008;

Call Translate_Axis;




curves_id_1[] = {2735, 2744, 2745, 2741};
curves_id_2[] = {2685, 2686, 2698, 2691};
curves_id_3[] = {2612,2615};
volume_id_1 = 45;
volume_id_2 = 48;
volume_id_3 = 49;
volume_id_4 = 50;
volume_id_5 = 51;
volume_id_6 = 52;
volume_id_7 = 53;
volume_id_8 = 46;
volume_id_9 = 47;
Call Weld_bolt;

Physical Volume("Bolt 1") = {new_volume_1};

curves_id_1[] = {2481, 2482, 2471, 2468};
curves_id_2[] = {2566, 2578, 2571, 2565};
curves_id_3[] = {2432,2429};
volume_id_1 = 36;
volume_id_2 = 37;
volume_id_3 = 38;
volume_id_4 = 39;
volume_id_5 = 42;
volume_id_6 = 43;
volume_id_7 = 44;
volume_id_8 = 40;
volume_id_9 = 41;
Call Weld_bolt;

Physical Volume("Bolt 2") = {new_volume_1};

curves_id_1[] = {2844, 2845, 2838, 2835};
curves_id_2[] = {2881, 2874, 2868, 2869};
curves_id_3[] = {2796,2799};
volume_id_1 = 54;
volume_id_2 = 55;
volume_id_3 = 56;
volume_id_4 = 57;
volume_id_5 = 58;
volume_id_6 = 61;
volume_id_7 = 62;
volume_id_8 = 59;
volume_id_9 = 60;
Call Weld_bolt;

Physical Volume("Bolt 3") = {new_volume_1};

allVolumes[] = Volume "*";
BooleanFragments{ Volume{allVolumes[] }; Delete; }{}

// Realign the axis
point_OX_1 = 3292;
point_OX_2 = 3318;

point_OY_1 = 3292;
point_OY_2 = 3290;

Call Rotate_Axis;

Mesh.Algorithm = 6;
Mesh.Algorithm3D = 4;
Mesh.CharacteristicLengthMin = 0.0015;
Mesh.CharacteristicLengthMax = 0.0015;

Recursive Delete { Volume{3,17,18}; }

Physical Surface("Mirror surface") = {1422};

Physical Surface("Holder x clamping") = {2410,2628};
Physical Surface("Holder y-z clamping") = {2508,2507,2409,2408,2505,2506,2503,2504};
//+
Physical Surface("Cooling channels") = {2553, 2519, 2474, 2529, 2468, 2469, 2475, 2639, 2545, 2536, 2578, 2577, 2551, 2520, 2543, 2524, 2550, 2554, 2555, 2538, 2476, 2470, 2467, 2473, 2471, 2477, 2534, 2516, 2575, 2540, 2542, 2535, 2530, 2648, 2541, 2531, 2537, 2576, 2517, 2478, 2458, 2486, 2466, 2459, 2479, 2480, 2460, 2485, 2465, 2644, 2552, 2461, 2481, 2484, 2464, 2482, 2462, 2483, 2463, 2533, 2513, 2544, 2549, 2573, 2574, 2547, 2515, 2532, 2548, 2514, 2512, 2546, 2527, 2528, 2526, 2518, 2643, 2642, 2523, 2525, 2640, 2539, 2522, 2641, 2521, 2647, 2646, 2645};
//+
Physical Surface("Cooling channels") += {2125, 2121, 2120, 2123, 2096, 2107, 2097, 2108, 2109, 2110, 2104, 2103, 2119, 2118, 2117, 2116, 2115, 2098, 2099, 2114, 2113, 2100, 2112, 2101, 2111, 2102, 2124, 2105, 2106};
//+
Physical Surface("Cooling channels") += {2245, 2243, 2244, 2265, 2266};
//+
Physical Surface("Cooling channels") += {2678, 2677, 2676, 2675, 2748, 2744, 2673, 2674, 2310, 2315, 2311, 2316, 2312, 2317, 2313, 2318, 2319, 2314, 2724, 2720, 2732, 2736, 2334, 2339, 2335, 2340, 2336, 2341, 2342, 2337, 2343, 2338, 2730, 2726, 2662, 2663, 2660, 2661, 2658, 2659, 2738, 2742, 2714, 2718};

Physical Volume("Nut 3") = {63,64,65};
