// $Id$
// fichier de donnees gmsh

C1 = 10;
C2 = 10;
nC1 = 16;
nC2 = 16;

theta = 0*Pi/4;
dx = 0;
dy = 0;
dz = 0.1;
lc = 1;

Point(1) = { 0,   0, 0, lc};
Point(2) = { C1,   0, 0, lc};
Point(3) = { C1, 0, C1, lc};
Point(4) = { 0, 0, C1, lc};

Point(5) = { 0,   0, C1+dz, lc};
Point(6) = { C2,   0, C1+dz, lc};
Point(7) = { C2, 0, C1+C2+dz, lc};
Point(8) = { 0, 0, C1+C2+dz, lc};

Line(1) = {1, 2};
Line(2) = {2, 3};
Line(3) = {3, 4};
Line(4) = {4, 1};

Line(5) = {5, 6};
Line(6) = {6, 7};
Line(7) = {7, 8};
Line(8) = {8, 5};

Transfinite Line {1,2,3,4} = nC1+1 Using Progression 1;
Transfinite Line {5,6,7,8} = nC2+1 Using Progression 1;

Line Loop(11) = {1,2,3,4};
Plane Surface(12) = {11};
Transfinite Surface {12};
Recombine Surface {12};

Extrude {0, C1, 0}
{
  Surface{12}; Layers{nC1}; Recombine;
}

Line Loop(13) = {5,6,7,8};
Plane Surface(14) = {13};
Transfinite Surface {14};
Recombine Surface {14};

Rotate {{0,0,1}, {0,0,0}, theta}{Surface{14};}

Extrude {-C2*Sin(theta), C2*Cos(theta), 0}
{
  Surface{14}; Layers{nC2}; Recombine;
}

Translate  {dx,dy,0}  { Volume{2};}

// physical entities

Physical Volume("Body 1") = {1};
Physical Volume("Body 2") = {2};

Physical Surface("Surf 1 1") = {-21};
Physical Surface("Surf 1 2") = {-29};

Physical Surface("Surf 2 1") = {-43};
Physical Surface("Surf 2 2") = {-51};

Mesh.Partitioner = 2;
Mesh.MetisAlgorithm = 2;
Mesh.MshFilePartitioned = 0;
