// $Id$
// fichier de donnees gmsh

C1 = 10;
C2 = 10;
C3 = 10;
nC1 = 16;
nC2 = 16;
nC3 = 16;

theta1 = 0*Pi/4;
theta2 = 0*Pi/4;

dx1 = 0;
dy1 = 0;
dz1 = 0.1;
dx2 = 0;
dy2 = 0;
dz2 = 0.1;
lc = 1;

Point(1) = { 0,   0, 0, lc};
Point(2) = { C1,   0, 0, lc};
Point(3) = { C1, 0, C1, lc};
Point(4) = { 0, 0, C1, lc};

Point(5) = { 0,   0, C1+dz1, lc};
Point(6) = { C2,   0, C1+dz1, lc};
Point(7) = { C2, 0, C1+C2+dz1, lc};
Point(8) = { 0, 0, C1+C2+dz1, lc};

Point(9) = { 0,   0, C1+C2+dz1+dz2, lc};
Point(10) = { C3,   0, C1+C2+dz1+dz2, lc};
Point(11) = { C3, 0, C1+C2+C3+dz1+dz2, lc};
Point(12) = { 0, 0, C1+C2+C3+dz1+dz2, lc};

Line(1) = {1, 2};
Line(2) = {2, 3};
Line(3) = {3, 4};
Line(4) = {4, 1};

Line(5) = {5, 6};
Line(6) = {6, 7};
Line(7) = {7, 8};
Line(8) = {8, 5};

Line(9) = {9, 10};
Line(10) = {10, 11};
Line(11) = {11, 12};
Line(12) = {12, 9};

Transfinite Line {1,2,3,4} = nC1+1 Using Progression 1;
Transfinite Line {5,6,7,8} = nC2+1 Using Progression 1;
Transfinite Line {9,10,11,12} = nC3+1 Using Progression 1;

Line Loop(13) = {1,2,3,4};
Plane Surface(14) = {13};
Transfinite Surface {14};
Recombine Surface {14};

Extrude {0, C1, 0}
{
  Surface{14}; Layers{nC1}; Recombine;
}

Line Loop(15) = {5,6,7,8};
Plane Surface(16) = {15};
Transfinite Surface {16};
Recombine Surface {16};

Rotate {{0,0,1}, {0,0,0}, theta1}{Surface{16};}

Extrude {-C2*Sin(theta1), C2*Cos(theta1), 0}
{
  Surface{16}; Layers{nC2}; Recombine;
}

Translate  {dx1,dy1,0}  { Volume{2};}

Line Loop(17) = {9,10,11,12};
Plane Surface(18) = {17};
Transfinite Surface {18};
Recombine Surface {18};

Rotate {{0,0,1}, {0,0,0}, theta2}{Surface{18};}

Extrude {-C3*Sin(theta2), C3*Cos(theta2), 0}
{
  Surface{18}; Layers{nC3}; Recombine;
}

Translate  {dx2,dy2,0}  { Volume{3};}

// physical entities

Physical Volume("Body 1") = {1};
Physical Volume("Body 2") = {2};
Physical Volume("Body 3") = {3};

Physical Surface("Surf 1 1") = {-23};
Physical Surface("Surf 1 2") = {-31};

Physical Surface("Surf 2 1") = {-45};
Physical Surface("Surf 2 2") = {-53};

Physical Surface("Surf 3 1") = {-67};
Physical Surface("Surf 3 2") = {-75};

