// $Id$
// fichier de donnees gmsh


//L = 50.;
//W = 1.;
//H = 5.;
//d = 1.;

L = 50.;
W = 5.;
H = 5.;
H_rigid = 1.;
d = 1.;

hW = W/2;
hH = H/2;

n_L = 50;
n_W = 5;
n_H = 5;

n_L_rigid = 1;
n_W_rigid = 1;
n_H_rigid = 1;


lc = 1;

delta_H = hH+d;

Point(1) = { 0,  -hW,    d, lc};
Point(2) = { 0,   hW,    d, lc};
Point(3) = { L,   hW,    d, lc};
Point(4) = { L,  -hW,    d, lc};

Point(5) = { 0,   -hW, 0, lc};
Point(6) = { 0,    hW, 0, lc};
Point(7) = { L,    hW, 0, lc};
Point(8) = { L,   -hW, 0, lc};

Line(1) = {1, 2};
Line(2) = {2, 3};
Line(3) = {3, 4};
Line(4) = {4, 1};

Line(5) = {5, 6};
Line(6) = {6, 7};
Line(7) = {7, 8};
Line(8) = {8, 5};

Transfinite Line {1,3} = n_W+1 Using Progression 1;
Transfinite Line {2,4} = n_L+1 Using Progression 1;

Transfinite Line {5,7} = n_W_rigid+1 Using Progression 1;
Transfinite Line {6,8} = n_L_rigid+1 Using Progression 1;

Line Loop(1) = {1, 2, 3, 4};
Plane Surface(1) = {1};
Transfinite Surface {1};
Recombine Surface {1};

//Line Loop(2) = {5,6,7,8};
Line Loop(2) = {-8,-7,-6,-5};
Plane Surface(2) = {2};
Transfinite Surface {2};
Recombine Surface {2};

Extrude {0, 0, H}
{
  Surface{1}; Layers{n_H}; Recombine;
}

Extrude {0, 0, -H_rigid}
{
  Surface{2}; Layers{n_H_rigid}; Recombine;
}



Physical Volume("Rigid body") = {2};
Physical Surface("Rigid surface") = {2};
Physical Surface("Rigid clamped surface") = {51};
Physical Line("Rigid surface boundary") = {5, 6, 7, 8};

Physical Volume("Beam") = {1};
Physical Surface("Clamped end") = {17};
Physical Surface("Loaded surface") = {30};
Physical Surface("Beam contact zone") = {1};
Physical Surface("Free end") = {25, 43};
Physical Line("Beam contact boundary") = {1, 2, 3, 4};
Physical Line("Beam contact Dirichlet") = {1};

Mesh.Partitioner = 2;
Mesh.MetisAlgorithm = 2;
Mesh.MshFilePartitioned = 0;
