#!/bin/bash
# Submission script for Bowman
#SBATCH --job-name=beam_UQ_1
#SBATCH --time=05:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p knl-delta
#
#SBATCH --comment=test
#SBATCH --output=workspace/beam_UQ_1.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

env | egrep ^SLURM
module list

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=256
export KMP_PLACE_THREADS=4T
export KMP_AFFINITY=scatter

cd /home/knliege/dev/waves

python run.py --nogui -k ${OMP_NUM_THREADS} mrstlnos/tests/beam_UQ_1.py

