// Gmsh project created on Fri Apr 14 10:22:24 2017
SetFactory("OpenCASCADE");

holder_height = 0.6;
spacer_height = 0.3;
L = spacer_height+2*holder_height;
head_height = 0.3;
head_height_2 = 0.1;

bolt_radius = 0.2;
bolt_head_radius = 0.65;
bolt_spacer_radius = 0.65;
spacer_out_radius = 0.75;
spacer_in_radius = 0.4;
holder_in_radius = 0.25;

holder_in_radius2 = 0.23;


radius1 =0.75;
//+
radius2 = 0.1;
//+
radius3 = 0.05;
//+
radius4 = 0.1;


// Bolt
//+
Cylinder(101) = {0, 0, L/2, 0, 0, -holder_height, bolt_radius, 2*Pi};
Cylinder(1001) = {0, 0, L/2-holder_height, 0, 0, -spacer_height/2, bolt_radius, 2*Pi};
Cylinder(1002) = {0, 0, L/2-holder_height-spacer_height/2, 0, 0, -spacer_height/2, bolt_radius, 2*Pi};
Cylinder(1003) = {0, 0, L/2-holder_height-spacer_height, 0, 0, -holder_height-2*head_height, bolt_radius, 2*Pi};
//Cylinder(1001) = {0, 0, L/2, 0, 0, -L-2*head_height, bolt_radius, 2*Pi};
//+
Cylinder(102) = {0, 0, -(L/2+head_height+head_height_2), 0, 0, head_height, bolt_head_radius, 2*Pi};
Cylinder(1021) = {0, 0, -L/2, 0, 0, -0.1*head_height, holder_in_radius2, 2*Pi};
//+
Cylinder(103) = {0, 0, L/2+head_height_2, 0, 0, head_height, bolt_head_radius, 2*Pi};
Cylinder(1031) = {0, 0, L/2, 0, 0, 0.1*head_height, holder_in_radius2, 2*Pi};
//+
Block(104) = {-bolt_head_radius, 0.6*bolt_head_radius, -(L/2+head_height+head_height_2), 2*bolt_head_radius, 2*bolt_head_radius, L+2*head_height+2*head_height_2};
//+
Block(105) = {-bolt_head_radius, 0.6*bolt_head_radius, -(L/2+head_height+head_height_2), 2*bolt_head_radius, 2*bolt_head_radius, L+2*head_height+2*head_height_2};
//+
Block(106) = {-bolt_head_radius, 0.6*bolt_head_radius, -(L/2+head_height+head_height_2), 2*bolt_head_radius, 2*bolt_head_radius, L+2*head_height+2*head_height_2};
//+
Block(107) = {-bolt_head_radius, 0.6*bolt_head_radius, -(L/2+head_height+head_height_2), 2*bolt_head_radius, 2*bolt_head_radius, L+2*head_height+2*head_height_2};
//+
Block(108) = {-bolt_head_radius, 0.6*bolt_head_radius, -(L/2+head_height+head_height_2), 2*bolt_head_radius, 2*bolt_head_radius, L+2*head_height+2*head_height_2};
//+
Block(109) = {-bolt_head_radius, 0.6*bolt_head_radius, -(L/2+head_height+head_height_2), 2*bolt_head_radius, 2*bolt_head_radius, L+2*head_height+2*head_height_2};
//+
Rotate {{0, 0, 1}, {0, 0, 0}, Pi/3} {
  Volume{105};
}
//+
Rotate {{0, 0, 1}, {0, 0, 0}, 2*Pi/3} {
  Volume{106};
}
//+
Rotate {{0, 0, 1}, {0, 0, 0}, 3*Pi/3} {
  Volume{107};
}
//+
Rotate {{0, 0, 1}, {0, 0, 0}, 4*Pi/3} {
  Volume{108};
}
//+
Rotate {{0, 0, 1}, {0, 0, 0}, 5*Pi/3} {
  Volume{109};
}
//+
BooleanDifference{ Volume{103}; Volume{102}; Delete; }{ Volume{107}; Volume{106}; Volume{105}; Volume{108}; Volume{109}; Volume{104}; Delete; }
//+
Cylinder(121) = {0, 0, -(L/2+head_height_2), 0, 0, head_height_2, bolt_spacer_radius, 2*Pi};
//+
Cylinder(122) = {0, 0, L/2, 0, 0, head_height_2, bolt_spacer_radius, 2*Pi};
//+
BooleanUnion{ Volume{101}; Delete; }{Volume{1001}; Volume{1002};Volume{1003}; Volume{102}; Volume{1021}; Volume{121}; Volume{122}; Volume{103}; Volume{1031}; Delete; }


// Holder
//+
Block(8) = {-1.5, -1.5, -L/2, 2.5, 2.5, holder_height};
//+
Cylinder(9) = {0, 0, -L/2, 0, 0, holder_height, holder_in_radius, 2*Pi};
Cylinder(10) = {0, 0, -L/2, 0, 0, 0.1*holder_height, bolt_head_radius, 2*Pi};
Cylinder(11) = {0, 0, -L/2+holder_height, 0, 0, -0.1*holder_height, spacer_out_radius, 2*Pi};
//+
BooleanUnion{Volume{8}; Delete; }{ Volume{10}; Volume{11}; Delete; }
//+
BooleanDifference{ Volume{10}; Delete; }{ Volume{9}; Delete; }


// Holder
//+
Block(12) = {-1.5, -1.5, L/2-holder_height, 2.5, 2.5, holder_height};
//+
Cylinder(13) = {0, 0, L/2-holder_height, 0, 0, holder_height, holder_in_radius, 2*Pi};
Cylinder(14) = {0, 0, L/2-holder_height+holder_height, 0, 0, -0.1*holder_height, bolt_head_radius, 2*Pi};
Cylinder(15) = {0, 0, L/2-holder_height, 0, 0, 0.1*holder_height, spacer_out_radius, 2*Pi};
//+
BooleanUnion{Volume{12}; Delete; }{ Volume{14}; Volume{15}; Delete; }
//+
BooleanDifference{ Volume{14}; Delete; }{ Volume{13}; Delete; }


// Spacer
//+
Cylinder(15) = {0, 0, -L/2+holder_height, 0, 0, spacer_height/2, spacer_out_radius, 2*Pi};
Cylinder(16) = {0, 0, -L/2+holder_height+spacer_height/2, 0, 0, spacer_height/2, spacer_out_radius, 2*Pi};
Cylinder(17) = {0, 0, -L/2+holder_height, 0, 0, spacer_height/2, spacer_in_radius, 2*Pi};
Cylinder(18) = {0, 0, -L/2+holder_height+spacer_height/2, 0, 0, spacer_height/2, spacer_in_radius, 2*Pi};
//+
BooleanUnion{Volume{15}; Delete; }{ Volume{16}; Delete; }

//+
BooleanDifference{ Volume{19}; Delete; }{ Volume{18}; Volume{17}; Delete; }


//+
Fillet{14, 10}{112, 83}{radius1}
//+
Fillet{20, 21}{138, 136, 135, 141, 149, 144, 158, 156, 155, 164, 161, 169}{radius2}
//+
Fillet{1}{46, 56, 55, 53, 51, 49, 5, 7, 4, 6, 8, 9}{radius4}
Fillet{22}{251, 236}{radius3}
//+
Fillet{22}{242}{radius4}

//+
Physical Volume("Bolt") = {22};
//+
Physical Volume("Holder 1") = {20};
//+
Physical Volume("Holder 2") = {21};
//+
Physical Volume("Spacer") = {19};

Physical Surface("Bolt to Holder 1 vertical") = {141};
Physical Surface("Bolt to Holder 1 horizontal") = {139};

Physical Surface("Bolt to Holder 2 vertical") = {134};
Physical Surface("Bolt to Holder 2 horizontal") = {136};

Physical Surface("Bolt to Spacer") = {137,138};


Physical Surface("Spacer to Holder 1") = {82};
Physical Surface("Spacer to Holder 2") = {77};
Physical Surface("Spacer to Bolt") = {79,81};

Physical Surface("Holder 1 to Bolt vertical") = {89};
Physical Surface("Holder 1 to Bolt horizontal") = {96};

Physical Surface("Holder 1 to Spacer") = {98};
Physical Surface("Holder 1 end") = {84,86};

Physical Surface("Holder 2 to Bolt vertical") = {114};
Physical Surface("Holder 2 to Bolt horizontal") = {112};

Physical Surface("Holder 2 to Spacer") = {105};
Physical Surface("Holder 2 end") = {100,102};


Physical Line("Spacer XY clamp") = {131};

Physical Line("Bolt XY clamp") = {248};
