#!/bin/bash
# Submission script for Bowman
#SBATCH --job-name=cube_UQ_EP
#SBATCH --time=05:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p knl-delta
#
#SBATCH --comment=test
#SBATCH --output=workspace/cube_UQ_EP.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

env | egrep ^SLURM
module list

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=256
export KMP_PLACE_THREADS=4T
export KMP_AFFINITY=scatter




export scenario=1
export size=8

cd /home/knliege/dev/waves

python run.py --nogui -k ${OMP_NUM_THREADS} mrstlnos/tests/cube_UQ_${size}_scenario_${scenario}.py
