// Gmsh project created on Sat Sep  2 12:32:37 2017
SetFactory("OpenCASCADE");

L = 1.;
//H = 0.25;
H = 0.5;
//R_1 = 0.1;
R_1 = 0.2;
R_2 = 0.45;
//R_2 = 0.4;
R_3 = 0.5;
d = 0.;

n_1 = 20;
n_2 = 10;
n_3 = 20;
n_4 = 10;
n_5 = 1;
n_6 = 1;

theta = Pi/4;

lc = 0.1;

Point(1) = { 0, 0, 0, lc};

Point(2) = {  R_1*Cos(theta),  R_1*Sin(theta), 0, lc};
Point(3) = {  R_1*Cos(theta), -R_1*Sin(theta), 0, lc};
Point(4) = { -R_1*Cos(theta), -R_1*Sin(theta), 0, lc};
Point(5) = { -R_1*Cos(theta),  R_1*Sin(theta), 0, lc};

Point(6) = {  R_2*Cos(theta),  R_2*Sin(theta), 0, lc};
Point(7) = {  R_2*Cos(theta), -R_2*Sin(theta), 0, lc};
Point(8) = { -R_2*Cos(theta), -R_2*Sin(theta), 0, lc};
Point(9) = { -R_2*Cos(theta),  R_2*Sin(theta), 0, lc};

Point(10) = {  R_3*Cos(theta),  R_3*Sin(theta), 0, lc};
Point(11) = {  R_3*Cos(theta), -R_3*Sin(theta), 0, lc};
Point(12) = { -R_3*Cos(theta), -R_3*Sin(theta), 0, lc};
Point(13) = { -R_3*Cos(theta),  R_3*Sin(theta), 0, lc};

Point(14) = {  L,  L, 0, lc};
Point(15) = {  L, -L, 0, lc};
Point(16) = { -L, -L, 0, lc};
Point(17) = { -L,  L, 0, lc};


Line(1) = {2, 3};
Line(2) = {3, 4};
Line(3) = {4, 5};
Line(4) = {5, 2};

Line(5) = {2, 6};
Line(6) = {3, 7};
Line(7) = {4, 8};
Line(8) = {5, 9};

Circle(9) = {6, 1, 7};
Circle(10) = {7, 1, 8};
Circle(11) = {8, 1, 9};
Circle(12) = {9, 1, 6};

Circle(13) = {10, 1, 11};
Circle(14) = {11, 1, 12};
Circle(15) = {12, 1, 13};
Circle(16) = {13, 1, 10};

Line(17) = {14, 15};
Line(18) = {15, 16};
Line(19) = {16, 17};
Line(20) = {17, 14};

Line(21) = {10, 14};
Line(22) = {11, 15};
Line(23) = {12, 16};
Line(24) = {13, 17};



Transfinite Line {1,2,3,4} = n_1+1 Using Progression 1;

Transfinite Line {5,6,7,8} = n_2+1 Using Progression 1;
Transfinite Line {9,10,11,12} = n_1+1 Using Progression 1;

Transfinite Line {13,14,15,16} = n_3+1 Using Progression 1;
Transfinite Line {17,18,19,20} = n_3+1 Using Progression 1;

Transfinite Line {21,22,23,24} = n_4+1 Using Progression 1;


Line Loop(51) = {1,2,3,4};
Plane Surface(51) = {51};
Transfinite Surface {51};
Recombine Surface {51};


Line Loop(101) = {9,-6,-1,5};
Plane Surface(101) = {101};
Transfinite Surface {101};
Recombine Surface {101};

Line Loop(102) = {10,-7,-2,6};
Plane Surface(102) = {102};
Transfinite Surface {102};
Recombine Surface {102};

Line Loop(103) = {11,-8,-3,7};
Plane Surface(103) = {103};
Transfinite Surface {103};
Recombine Surface {103};

Line Loop(104) = {12,-5,-4,8};
Plane Surface(104) = {104};
Transfinite Surface {104};
Recombine Surface {104};


Line Loop(301) = {17,-22,-13,21};
Plane Surface(301) = {301};
Transfinite Surface {301};
Recombine Surface {301};

Line Loop(302) = {18,-23,-14,22};
Plane Surface(302) = {302};
Transfinite Surface {302};
Recombine Surface {302};

Line Loop(303) = {19,-24,-15,23};
Plane Surface(303) = {303};
Transfinite Surface {303};
Recombine Surface {303};

Line Loop(304) = {20,-21,-16,24};
Plane Surface(304) = {304};
Transfinite Surface {304};
Recombine Surface {304};


Extrude {0, 0, H}
{
  Surface{51, 101, 102, 103, 104}; Layers{n_5}; Recombine;
}

Extrude {0, 0, H}
{
  Surface{301,302,303,304}; Layers{n_6}; Recombine;
}


Physical Surface("sym xy", 19) = {101, 102, 103, 104, 301, 302, 303, 304, 313, 316, 319, 321, 326, 330, 334, 337};
//+
Physical Surface("cylinder contact", 22) = {310, 314, 317, 320};
//+
Physical Surface("block contact", 23) = {324, 329, 333, 336};
//+
Physical Surface("moved", 24) = {51, 309};
//+
Physical Surface("clamped", 25) = {322, 327, 331, 335};
//+
Physical Volume("cylinder", 26) = {1, 2, 3, 4, 5};
//+
Physical Volume("block", 27) = {6, 7, 8, 9};
//+
//Rotate {{0, 1, 1}, {0, 0, 0}, Pi/4} {
//  Surface{304}; Surface{301}; Surface{104}; Surface{101}; Surface{51}; Surface{103}; Surface{303}; Surface{102}; Surface{302}; 
//}
//+
//Point(34) = {0.40543786053180508, 0.16793786053180507, 0.25, 1.0};
