#!/usr/bin/env python
# -*- coding: latin-1; -*-
# runs the basic demo of Trilinos
# trilinos-12.6.1-Source/demos/buildAgainstTrilinos

import fwk.wutils as wu
import mrstlnos

def main(**d):
    try:
        import mpi4py.MPI as mpi
        comm = mpi.COMM_WORLD
        rank = comm.rank
        siz  = comm.size
        name = mpi.Get_processor_name()
        status = mpi.Status()
        print "info: MPI found"
    except:
        comm = None
        rank = 0
        siz  = 1
        name = "noname"
        print "info: MPI not found => MPI disabled"    

    import numpy as np
    from PyTrilinos import Teuchos
    nx = 500 # = ny
    num_CG_iters = 100000 
    E = np.array([1,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32], dtype=int)
    d = E.shape[0]
    for i in range(0,d):
        expl = mrstlnos.Example2()
        expl.execute(nx, num_CG_iters, E[i], comm)
if __name__ == "__main__":
    main()
    
