// Gmsh project created on Sat Sep  2 12:32:37 2017
SetFactory("OpenCASCADE");

L = 1.;
H = 0.5;
R = 0.5;
d = 0.1;

theta = -Pi/3;

//+
Block(1) = {0, 0, 0, L, L, H};
//+
Cylinder(2) = {0, 0, 0, 0, 0, H, R*Cos(theta), Pi/2};
//+
Sphere(3) = {0, 0, R+H+d, R, -Pi/2, theta, Pi/2};
//+
Sphere(4) = {0, 0, R+H+d, R, theta, 0, Pi/2};
//+
//BooleanIntersection{ Volume{1}; }{ Volume{2}; }
//+
BooleanDifference{ Volume{1}; Delete; }{ Volume{2}; }
//+
BooleanUnion{ Volume{1}; Delete; }{ Volume{2}; Delete;}
//+
BooleanUnion{ Volume{3}; Delete; }{ Volume{4}; Delete;}

//+
Physical Surface("sym yz", 20) = {21, 22, 34, 37};
//+
Physical Surface("sym xz", 21) = {27, 30, 33, 36};
//+
Physical Surface("sphere contact", 22) = {35};
//+
Physical Surface("block contact", 23) = {26};
//+
Physical Surface("moved", 24) = {31};
//+
Physical Surface("clamped", 25) = {25, 28};
//+
Physical Volume("sphere", 26) = {6};
//+
Physical Volume("block", 27) = {5};
//+
Physical Line("sphere Dirichlet contact", 28) = {58};
//+
Physical Line("sphere boundary of contact", 29) = {63, 67, 69};
//+
Physical Line("block boundary of contact", 30) = {42, 48, 54};




