#!/bin/bash
# Submission script for Bowman
#SBATCH --job-name=compare_m_balanced
#SBATCH --time=05:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p knl-delta
#
#SBATCH --comment=test
#SBATCH --output=workspace/exe6/compare_m_balanced.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

env | egrep ^SLURM
module list

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=256
export KMP_PLACE_THREADS=4T
export KMP_AFFINITY=balanced,verbose

export test_name=compare_m_balanced_${SLURM_JOBID}_

export m=100000
export n=1
export k=300
export N=20
export m_max_min=1
export m_max_max=301
export d_m_max=1

cd ~/dev/waves/workspace/
if [ ! -d "exe6" ]; then
  mkdir exe6
fi

cd exe6

./../../../wavesB/bin/compare_m --kokkos-threads=256 -f $test_name -m $m -n $n -k $k -N $N -m_max_min $m_max_min -m_max_max $m_max_max -d_m_max $d_m_max
