#!/bin/bash
# Submission script for Bowman
#SBATCH --job-name=compare_m_compact
#SBATCH --time=05:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p knl-delta
#
#SBATCH --comment=test
#SBATCH --output=workspace/exe7/compare_m_compact.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

env | egrep ^SLURM
module list

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=256
export KMP_PLACE_THREADS=4T
export KMP_AFFINITY=compact,verbose

export test_name=compare_m_compact_${SLURM_JOBID}_

export m=100000
export n=1
export N=20
export k_min=10
export k_max=301
export d_k=1

cd ~/dev/waves/workspace/
if [ ! -d "exe7" ]; then
  mkdir exe7
fi

cd exe7

./../../../wavesB/bin/compare_m2 --kokkos-threads=256 -f $test_name -m $m -n $n -N $N -k_min $k_min -kmax $k_max -d_k $d_k