#include "Stokhos_Sacado_Kokkos_MP_Vector.hpp"

#include "DefaultGEMV_decl.hpp"
#include "DefaultGEMV_def.hpp"

//using namespace DefaultGEMV;

typedef int IndexType;

#define SCALAR double
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutLeft, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_row_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR double
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutRight, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_row_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR double
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutLeft, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_col_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR double
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutRight, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_col_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,8,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutLeft, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_row_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,8,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutRight, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_row_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,8,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutLeft, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_col_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,8,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutRight, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_col_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,16,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutLeft, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_row_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,16,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutRight, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_row_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,16,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutLeft, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_col_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,16,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutRight, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_col_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,24,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutLeft, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_row_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,24,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutRight, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_row_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,24,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutLeft, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_col_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,24,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutRight, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_col_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,32,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutLeft, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_row_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,32,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutRight, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_row_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,32,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutLeft, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_col_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR

#define SCALAR Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,32,Kokkos::OpenMP>>
#define VT Kokkos::View<SCALAR**, Kokkos::LayoutRight, Kokkos::Device<Kokkos::OpenMP, Kokkos::HostSpace>, Kokkos::MemoryTraits<(unsigned int)0>>

template void DefaultGEMV::GEMV_col_based <VT,VT,VT,SCALAR,IndexType>(
      const char transA,
      const char transB,
      const SCALAR& alpha,
      const VT& A,
      const VT& B,
      const SCALAR& beta,
      const VT& C);

#undef VT
#undef SCALAR
