class InputParser{
    public:
        InputParser (int &argc, char **argv){
            for (int i=1; i < argc; ++i)
                this->tokens.push_back(std::string(argv[i]));
        }
        /// @author iain
        const std::string& getCmdOption(const std::string &option) const{
            std::vector<std::string>::const_iterator itr;
            itr =  std::find(this->tokens.begin(), this->tokens.end(), option);
            if (itr != this->tokens.end() && ++itr != this->tokens.end()){
                return *itr;
            }
            static const std::string empty_string("");
            return empty_string;
        }
        /// @author iain
        bool cmdOptionExists(const std::string &option) const{
            return std::find(this->tokens.begin(), this->tokens.end(), option)
                   != this->tokens.end();
        }
    private:
        std::vector <std::string> tokens;
};



void readInput(int argc, char **argv, std::string &filename, int &m, int &n, int &N, int &k_min, int &k_max, int &d_k, int &per_tile)
{
    InputParser input(argc, argv);

    if(input.cmdOptionExists("-h")){
        std::cout << "Help:" <<std::endl;
        std::cout << "-h : show this help" <<std::endl;
        std::cout << "-f [filename] : example -f test" <<std::endl;
        std::cout << "-m [m] : example -m 300000" <<std::endl;
        std::cout << "-n [n] : example -n 1" <<std::endl;
        std::cout << "-N [N] : example -N 10" <<std::endl;
        std::cout << "-k_min [k_min] : example -k_min 10" <<std::endl;
        std::cout << "-k_max [k_max] : example -k_max 1000" <<std::endl;
        std::cout << "-d_k [d_k] : example -d_k 10" <<std::endl;
        std::cout << "-algo [algo] : example -algo 1" <<std::endl;
        std::cout << "full example:"<<std::endl;
        std::cout << "./compare_m3 -f test -m 300000 -n 1 -N 10 -k_min 10 -k_max 1000 -d_k 10"<<std::endl;
        m = -1;
        return ;
    }

    //std::string filename;
    const std::string &filename_read = input.getCmdOption("-f");
    if(filename_read.empty())
    {
      filename = std::string("test");
      std::cout << "Default file name: " << filename << std::endl;
    }
    else
      filename = filename_read;

    //int m;

    const std::string &m_string = input.getCmdOption("-m");
    if(m_string.empty())
      m = 3000;
    else
      m = std::stoi(m_string);

    //int n = 1;

    const std::string &n_string = input.getCmdOption("-n");
    if(n_string.empty())
      n = 1;
    else
      n = std::stoi(n_string);

    //int N;

    const std::string &N_string = input.getCmdOption("-N");
    if(N_string.empty())
      N = 100;
    else
      N = std::stoi(N_string);   

    //int k_min;   

    const std::string &k_min_string = input.getCmdOption("-k_min");
    if(k_min_string.empty())
      k_min = 10;
    else
      k_min = std::stoi(k_min_string);   

    //int k_max;   

    const std::string &k_max_string = input.getCmdOption("-k_max");
    if(k_max_string.empty())
      k_max = 100;
    else
      k_max = std::stoi(k_max_string);   

    //int d_k;   

    const std::string &d_k_string = input.getCmdOption("-d_k");
    if(d_k_string.empty())
      d_k = 10;
    else
      d_k = std::stoi(d_k_string);
  
    //int per_tile;

    const std::string &per_tile_string = input.getCmdOption("-per_tile");
    if(per_tile_string.empty())
      per_tile = 100;
    else
      per_tile = std::stoi(per_tile_string);
}
