
#include "mkl.h"
namespace MKLGEMV{



template<class ViewType1,
         class ViewType2,
         class ViewType3,
         class Scalar,
         class IndexType>
void GEMV(
      const char transA,
      const char transB,
      const double alpha,
      const ViewType1& A,
      const ViewType2& B,
      const double beta,
      const ViewType3& C)
{
    // Assert that A, B, and C are in fact matrices
    static_assert (ViewType1::rank == 2, "GEMM: A must have rank 2 (be a matrix).");
    static_assert (ViewType2::rank == 2, "GEMM: B must have rank 2 (be a matrix).");
    static_assert (ViewType3::rank == 2, "GEMM: C must have rank 2 (be a matrix).");

    // Get the dimensions
    //const IndexType m = C.dimension_0 ();
    //const IndexType n = B.dimension_0 ();
  
    const IndexType m = A.dimension_0 ();
    const IndexType n = A.dimension_1 ();
  
    const IndexType n_rhs = C.dimension_1 ();
    bool trans_bool = (transA == 'N' || transA == 'n');

    //const IndexType n = trans_bool ? A.dimension_1 () : A.dimension_0 ();

    

   
    typedef typename ViewType1::array_layout array_layout;
    bool layoutL = std::is_same<array_layout, Kokkos::LayoutLeft>::value;   

    int strides[2]; 
    A.stride (strides);
    const int lda = layoutL ? strides[1] : strides[0];     

    double *a = &A(0,0);
    double *x = &B(0,0);
    double *y = &C(0,0);    

    

    //const CBLAS_TRANSPOSE trans = trans_bool ? CblasNoTrans : CblasTrans;

    //const CBLAS_LAYOUT layout = std::is_same<array_layout, Kokkos::LayoutLeft>::value ? CblasColMajor : CblasRowMajor;
    
    //cblas_dgemv(layout,trans, m, n, alpha, a, lda, x, 1, beta, y, 1);

    //std::cout << std::is_same<array_layout, Kokkos::LayoutLeft>::value << " " << std::is_same<array_layout, Kokkos::LayoutRight>::value << std::endl;

    //std::cout << A.dimension_0 () << " " <<" " << A.dimension_1 () << std::endl;
    //std::cout << lda << " " << m << " " <<" " << n << std::endl;

    if (layoutL)
    {
        if (trans_bool)
            ;//cblas_dgemv(CblasColMajor,CblasNoTrans, m, n, alpha, a, m, x, 1, beta, y, 1);
        else
            ;//cblas_dgemv(CblasColMajor,CblasTrans, m, n, alpha, a, m, x, 1, beta, y, 1);
    }
    else
    {
        if (trans_bool)
            ;//cblas_dgemv(CblasRowMajor,CblasNoTrans, m, n, alpha, a, n, x, 1, beta, y, 1);
        else
            ;//cblas_dgemv(CblasRowMajor,CblasTrans, m, n, alpha, a, n, x, 1, beta, y, 1);
    }
    //std::cout << lda << " " << m << " " <<" " << n << std::endl;
}

};
