#!/bin/bash
# Submission script for Bowman
#SBATCH --job-name=compare_m_balanced
#SBATCH --time=05:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p knl-delta
#
#SBATCH --comment=test
#SBATCH --output=workspace/exe9/compare_m_balanced.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

env | egrep ^SLURM
module list

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=256
export KMP_AFFINITY=balanced

export m=1889912
export n=1
export N=10
export k_min=1
export k_max=201
export d_k=1

export layout=-l

cd ~/dev/waves/workspace/
if [ ! -d "exe9" ]; then
  mkdir exe9
fi

cd exe9

export test_name=compare_m_balanced_update_${SLURM_JOBID}

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=256
export KMP_HW_SUBSET=64c,4t
export KMP_AFFINITY=balanced

cp ../../../wavesB/bin/compare_m3 compare_m3_${SLURM_JOBID}

./compare_m3_${SLURM_JOBID} --kokkos-threads=256 $layout -f $test_name -m $m -n $n -N $N -k_min $k_min -k_max $k_max -d_k $d_k -algo 13
