#!/bin/bash
# Submission script for Bowman
#SBATCH --job-name=compare_m_balanced
#SBATCH --time=30:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p knl-delta
#
#SBATCH --comment=test
#SBATCH --output=workspace/exe9/compare_m_balanced.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

env | egrep ^SLURM
module list

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=256
export KMP_AFFINITY=balanced

export n=1
export N=10
export k_min=10
export k_max=310
export d_k=10

export per_tile_min=8
export per_tile_max=408
export d_per_tile=8

export n_tile=768

export layout=-l

cd ~/dev/waves/workspace/
if [ ! -d "exe9" ]; then
  mkdir exe9
fi

cd exe9

export test_name=compare_m_balanced_update_per_tile_${SLURM_JOBID}

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=256
export KMP_HW_SUBSET=64c,4t
export KMP_AFFINITY=balanced

amplxe-cl -collect memory-access -result-dir r${SLURM_JOBID}_8mac_96 -call-stack-mode all -analyze-system ./../../../wavesB/bin/compare_m3 --kokkos-threads=256 $layout -f $test_name -m 98304 -n $n -N $N -k_min $k_min -k_max $k_max -d_k $d_k -algo 14 -per_tile 96 -ensemble 8
amplxe-cl -collect memory-access -result-dir r${SLURM_JOBID}_8mac_128 -call-stack-mode all -analyze-system ./../../../wavesB/bin/compare_m3 --kokkos-threads=256 $layout -f $test_name -m 131072 -n $n -N $N -k_min $k_min -k_max $k_max -d_k $d_k -algo 14 -per_tile 128 -ensemble 8
