#!/bin/bash
# Submission script for Bowman
#SBATCH --job-name=compare_m_compact
#SBATCH --time=05:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p knl-delta
#
#SBATCH --comment=test
#SBATCH --output=workspace/exe9/compare_m_compact.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

env | egrep ^SLURM
module list

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=256
export KMP_PLACE_THREADS=4T
export KMP_AFFINITY=compact

export m=100000
export n=1
export N=10
export k_min=9
export k_max=301
export d_k=1

export layout=-l

cd ~/dev/waves/workspace/
if [ ! -d "exe9" ]; then
  mkdir exe9
fi

cd exe9

algo_min=7
algo_max=14

algo=$algo_min

export test_name=compare_m_compact_flushed_${SLURM_JOBID}
./../../../wavesB/bin/compare_m3 --kokkos-threads=256 $layout -flush -f $test_name -m $m -n $n -N $N -k_min $k_min -k_max $k_max -d_k $d_k -algo 0
./../../../wavesB/bin/compare_m3 --kokkos-threads=256 $layout -flush -t -f $test_name -m $m -n $n -N $N -k_min $k_min -k_max $k_max -d_k $d_k -algo 0

while [ $algo -lt $algo_max ]
do
  ./../../../wavesB/bin/compare_m3 --kokkos-threads=256 $layout -flush -f $test_name -m $m -n $n -N $N -k_min $k_min -k_max $k_max -d_k $d_k -algo $algo
  ./../../../wavesB/bin/compare_m3 --kokkos-threads=256 $layout -flush -t -f $test_name -m $m -n $n -N $N -k_min $k_min -k_max $k_max -d_k $d_k -algo $algo
  algo=`expr $algo + 1`
done
