#ifndef Sacado_MP_Vector_GEMV_Has_Intel_Intrinsics

#if u==1
template<> KOKKOS_INLINE_FUNCTION
void inner_product_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c)
{
  c[0] += A[0]*b[0];
};
#endif

#if u==2
template<> KOKKOS_INLINE_FUNCTION
void inner_product_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c)
{
  c[0] += A[0]*b[0]+A[1]*b[1];
};
#endif

#if u==4
template<> KOKKOS_INLINE_FUNCTION
void inner_product_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c)
{
  c[0] += A[0]*b[0]+A[1]*b[1]+A[2]*b[2]+A[3]*b[3];
};
#endif

#if u==8
template<> KOKKOS_INLINE_FUNCTION
void inner_product_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c)
{
  c[0] += A[0]*b[0]+A[1]*b[1]+A[2]*b[2]+A[3]*b[3]+A[4]*b[4]+A[5]*b[5]+A[6]*b[6]+A[7]*b[7];
};
#endif

#if u==16
template<> KOKKOS_INLINE_FUNCTION
void inner_product_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c)
{
  c[0] += A[0]*b[0]+A[1]*b[1]+A[2]*b[2]+A[3]*b[3]+A[4]*b[4]+A[5]*b[5]+A[6]*b[6]+A[7]*b[7]+A[8]*b[8]+A[9]*b[9]+A[10]*b[10]+A[11]*b[11]+A[12]*b[12]+A[13]*b[13]+A[14]*b[14]+A[15]*b[15];
};
#endif

#if u==32
template<> KOKKOS_INLINE_FUNCTION
void inner_product_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c)
{
  c[0] += A[0]*b[0]+A[1]*b[1]+A[2]*b[2]+A[3]*b[3]+A[4]*b[4]+A[5]*b[5]+A[6]*b[6]+A[7]*b[7]+A[8]*b[8]+A[9]*b[9]+A[10]*b[10]+A[11]*b[11]+A[12]*b[12]+A[13]*b[13]+A[14]*b[14]+A[15]*b[15]+A[16]*b[16]+A[17]*b[17]+A[18]*b[18]+A[19]*b[19]+A[20]*b[20]+A[21]*b[21]+A[22]*b[22]+A[23]*b[23]+A[24]*b[24]+A[25]*b[25]+A[26]*b[26]+A[27]*b[27]+A[28]*b[28]+A[29]*b[29]+A[30]*b[30]+A[31]*b[31];
};
#endif

#else

template<> KOKKOS_INLINE_FUNCTION
void inner_product_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c)
{
  __m512d a_m, b_m, c_m;
  
  #pragma unroll (n_vectors)
  for (int j=0; j<n_vectors; ++j)
  {
  c_m = M512D_ENSEMBLE_LOAD(c[0],j);
    
    #pragma unroll (u)
    for (int i=0; i<u; ++i)
    {
      b_m = M512D_ENSEMBLE_LOAD(b[i],j);
      a_m = M512D_ENSEMBLE_LOAD(A[i],j);
      c_m = _mm512_fmadd_pd(a_m,b_m,c_m);
      M512D_ENSEMBLE_STORE(c[0],j,c_m);
    }
  }
};

#endif
