#ifndef Sacado_MP_Vector_GEMV_Has_Intel_Intrinsics

#if u==1
template<> KOKKOS_INLINE_FUNCTION
void update_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> alpha)
{
  auto tmp = alpha*b[0];
  c[0] += tmp*A[0];
};
#endif

#if u==2
template<> KOKKOS_INLINE_FUNCTION
void update_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> alpha)
{
  auto tmp = alpha*b[0];
  c[0] += tmp*A[0];
  c[1] += tmp*A[1];
};
#endif

#if u==4
template<> KOKKOS_INLINE_FUNCTION
void update_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> alpha)
{
  auto tmp = alpha*b[0];
  c[0] += tmp*A[0];
  c[1] += tmp*A[1];
  c[2] += tmp*A[2];
  c[3] += tmp*A[3];
};
#endif

#if u==8
template<> KOKKOS_INLINE_FUNCTION
void update_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> alpha)
{
  auto tmp = alpha*b[0];
  c[0] += tmp*A[0];
  c[1] += tmp*A[1];
  c[2] += tmp*A[2];
  c[3] += tmp*A[3];
  c[4] += tmp*A[4];
  c[5] += tmp*A[5];
  c[6] += tmp*A[6];
  c[7] += tmp*A[7];
};
#endif

#if u==16
template<> KOKKOS_INLINE_FUNCTION
void update_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> alpha)
{
  auto tmp = alpha*b[0];
  c[0] += tmp*A[0];
  c[1] += tmp*A[1];
  c[2] += tmp*A[2];
  c[3] += tmp*A[3];
  c[4] += tmp*A[4];
  c[5] += tmp*A[5];
  c[6] += tmp*A[6];
  c[7] += tmp*A[7];
  c[8] += tmp*A[8];
  c[9] += tmp*A[9];
  c[10] += tmp*A[10];
  c[11] += tmp*A[11];
  c[12] += tmp*A[12];
  c[13] += tmp*A[13];
  c[14] += tmp*A[14];
  c[15] += tmp*A[15];
};
#endif

#if u==32
template<> KOKKOS_INLINE_FUNCTION
void update_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> alpha)
{
  auto tmp = alpha*b[0];
  c[0] += tmp*A[0];
  c[1] += tmp*A[1];
  c[2] += tmp*A[2];
  c[3] += tmp*A[3];
  c[4] += tmp*A[4];
  c[5] += tmp*A[5];
  c[6] += tmp*A[6];
  c[7] += tmp*A[7];
  c[8] += tmp*A[8];
  c[9] += tmp*A[9];
  c[10] += tmp*A[10];
  c[11] += tmp*A[11];
  c[12] += tmp*A[12];
  c[13] += tmp*A[13];
  c[14] += tmp*A[14];
  c[15] += tmp*A[15];
  c[16] += tmp*A[16];
  c[17] += tmp*A[17];
  c[18] += tmp*A[18];
  c[19] += tmp*A[19];
  c[20] += tmp*A[20];
  c[21] += tmp*A[21];
  c[22] += tmp*A[22];
  c[23] += tmp*A[23];
  c[24] += tmp*A[24];
  c[25] += tmp*A[25];
  c[26] += tmp*A[26];
  c[27] += tmp*A[27];
  c[28] += tmp*A[28];
  c[29] += tmp*A[29];
  c[30] += tmp*A[30];
  c[31] += tmp*A[31];
};
#endif

#else

/*
template<> KOKKOS_INLINE_FUNCTION
void update_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> alpha)
{
  __m512d alpha_m, a_m, b_m, c_m;
  
  #pragma unroll (n_vectors)
  for (int j=0; j<n_vectors; ++j)
  {
  alpha_m = M512D_ENSEMBLE_LOAD(alpha,j);
  b_m = M512D_ENSEMBLE_LOAD(b[0],j);
  b_m = _mm512_mul_pd(b_m,alpha_m);
    
    #pragma unroll (u)
    for (int i=0; i<u; ++i)
    {
      c_m = M512D_ENSEMBLE_LOAD(c[i],j);
      a_m = M512D_ENSEMBLE_LOAD(A[i],j); // M512D_ENSEMBLE_STREAM_LOAD(A[i],j);
      c_m = _mm512_fmadd_pd(a_m,b_m,c_m);
      M512D_ENSEMBLE_STORE(c[i],j,c_m);
    }
  }
};
*/

template<> KOKKOS_INLINE_FUNCTION
void update_inner_kernel<Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>>,u>(
      Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * A, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * b, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> * c, Sacado::MP::Vector<Stokhos::StaticFixedStorage<int,double,size,Kokkos::OpenMP>> alpha)
{
  __m512d alpha_m[n_vectors], a_m[u][n_vectors], b_m[n_vectors], c_m[u][n_vectors];
  
  #pragma unroll (n_vectors)
  for (int j=0; j<n_vectors; ++j)
    alpha_m[j] = M512D_ENSEMBLE_LOAD(alpha,j);
  #pragma unroll (n_vectors)
  for (int j=0; j<n_vectors; ++j)
    b_m[j] = M512D_ENSEMBLE_LOAD(b[0],j);
  #pragma unroll (n_vectors)
  for (int j=0; j<n_vectors; ++j)
    b_m[j] = _mm512_mul_pd(b_m[j],alpha_m[j]);

  #pragma unroll (u)
  for (int i=0; i<u; ++i)
  {
    #pragma unroll (n_vectors)
    for (int j=0; j<n_vectors; ++j)
      c_m[i][j] = M512D_ENSEMBLE_LOAD(c[i],j);
    #pragma unroll (n_vectors)
    for (int j=0; j<n_vectors; ++j)
      a_m[i][j] = M512D_ENSEMBLE_LOAD(A[i],j);
    #pragma unroll (n_vectors)
    for (int j=0; j<n_vectors; ++j)
      c_m[i][j] = _mm512_fmadd_pd(a_m[i][j],b_m[j],c_m[i][j]);
    #pragma unroll (n_vectors)
    for (int j=0; j<n_vectors; ++j)
      M512D_ENSEMBLE_STORE(c[i],j,c_m[i][j]);
  }
  
};
#endif
