// $Id$
// fichier de donnees gmsh


//X=250m
//Y=250m
//Z=250m

L_1 = 50;
L_2 = 50;
L_3 = 50;
S_1_2 = 10;
S_2_3 = 10;
H_1 = 100;
H_2 = 100;
H_3 = 100;
W_1 = 100;
W_2 = 100;
W_3 = 100;


nL_1 = 5;
nL_2 = 8;
nL_3 = 7;
nH_1 = 6;
nH_2 = 9;
nH_3 = 8;
nW_1 = 5;
nW_2 = 8;
nW_3 = 7;
lc = 1;

Point(1) = { 0,   0, 0, lc};
Point(2) = { L_1,   0, 0, lc};
Point(3) = { L_1, 0, H_1, lc};
Point(4) = { 0, 0, H_1, lc};

Point(5) = { L_1+S_1_2,   0, 0, lc};
Point(6) = { L_1+S_1_2+L_2,   0, 0, lc};
Point(7) = { L_1+S_1_2+L_2, 0, H_2, lc};
Point(8) = { L_1+S_1_2, 0, H_2, lc};

Point(9) = { L_1+S_1_2+L_2+S_2_3,   0, 0, lc};
Point(10) = { L_1+S_1_2+L_2+S_2_3+L_3,   0, 0, lc};
Point(11) = { L_1+S_1_2+L_2+S_2_3+L_3, 0, H_3, lc};
Point(12) = { L_1+S_1_2+L_2+S_2_3, 0, H_3, lc};

Line(1) = {1, 2};
Line(2) = {2, 3};
Line(3) = {3, 4};
Line(4) = {4, 1};

Line(5) = {5, 6};
Line(6) = {6, 7};
Line(7) = {7, 8};
Line(8) = {8, 5};

Line(9) = {9, 10};
Line(10) = {10, 11};
Line(11) = {11, 12};
Line(12) = {12, 9};

Transfinite Line {1,3} = nL_1 Using Progression 1;
Transfinite Line {5,7} = nL_2 Using Progression 1;
Transfinite Line {9,11} = nL_3 Using Progression 1;
Transfinite Line {2,4} = nH_1 Using Progression 1;
Transfinite Line {6,8} = nH_2 Using Progression 1;
Transfinite Line {10,12} = nH_3 Using Progression 1;

Line Loop(11) = {1,2,3,4};
Plane Surface(12) = {11};
Transfinite Surface {12};
Recombine Surface {12};

Line Loop(13) = {5,6,7,8};
Plane Surface(14) = {13};
Transfinite Surface {14};
Recombine Surface {14};

Line Loop(15) = {9,10,11,12};
Plane Surface(16) = {15};
Transfinite Surface {16};
Recombine Surface {16};


Extrude {0, W_1, 0}
{
  Surface{12}; Layers{nW_1}; Recombine;
}

Extrude {0, W_2, 0}
{
  Surface{14}; Layers{nW_2}; Recombine;
}

Extrude {0, W_3, 0}
{
  Surface{16}; Layers{nW_3}; Recombine;
}



// physical entities

Physical Volume("Body 1") = {1};
Physical Volume("Body 2") = {2};
Physical Volume("Body 3") = {3};

Physical Surface("y sym") = {12,14,16};
Physical Surface("z sym") = {25,47,69};


Physical Surface("Body 1 surface x0") = {37};
Physical Surface("Body 1 surface x1") = {29};

Physical Surface("Body 2 surface x0") = {59};
Physical Surface("Body 2 surface x1") = {51};

Physical Surface("Body 3 surface x0") = {81};
Physical Surface("Body 3 surface x1") = {73};

Physical Point("Body 2 point x1") = {6};
