// $Id$
// fichier de donnees gmsh

gap = 0.;

Spacer_R_1 = 7.5;
Spacer_R_2 = 20;
Spacer_H = 10;

Holder_H = 10;
Holder_R_1 = 6;
Holder_R_2 = 15;
Holder_R_3 = 30;

Bolt_R_0 = 0.5;
Bolt_R_1 = 5;
Bolt_R_2 = 10;
Bolt_H = 5;

Bolt_L = 2*Bolt_H+2*Holder_H+Spacer_H;

nSpacer_R = 5;
nSpacer_H = 5;
nSpacer_Theta = 6; // for a quarter of the spacer (Pi/2)

nHolder_R = 5;
nHolder_H = 5;
nHolder_Theta = 6;
nHolder_G = 3;

nBolt_R_1 = 4;
nBolt_R_2 = 8;
nBolt_H = 4;
nBolt_l = 20;
nBolt_L = nBolt_l + 2*nBolt_H;
nBolt_Theta = 6;

lc = 1;

Point(1) = { Bolt_R_0,   0, 0, lc};
Point(2) = { Bolt_R_0,   0, Bolt_L, lc};
Point(3) = { Bolt_R_2, 0, Bolt_L, lc};
Point(4) = { Bolt_R_2, 0, Bolt_L-Bolt_H+gap, lc};
Point(5) = { Bolt_R_1, 0, Bolt_L-Bolt_H+gap, lc};
Point(6) = { Bolt_R_1, 0, Bolt_H-gap, lc};
Point(7) = { Bolt_R_2, 0, Bolt_H-gap, lc};
Point(8) = { Bolt_R_2, 0, 0, lc};

Point(9) = { Spacer_R_1, 0, Bolt_H+Holder_H+gap, lc};
Point(10) = { Spacer_R_1, 0, Bolt_L-Bolt_H-Holder_H-gap, lc};
Point(11) = { Spacer_R_2, 0, Bolt_L-Bolt_H-Holder_H-gap, lc};
Point(12) = { Spacer_R_2, 0, Bolt_H+Holder_H+gap, lc};


Point(13) = { Holder_R_1, 0, Bolt_H, lc}; //1
Point(14) = { Holder_R_2, 0, Bolt_H, lc};
Point(15) = { Holder_R_3, 0, Bolt_H, lc};

Point(16) = { 0, Holder_R_1, Bolt_H, lc};
Point(17) = { 0, Holder_R_2, Bolt_H, lc};
Point(18) = { 0, Holder_R_3, Bolt_H, lc};

Point(19) = { -Holder_R_1, 0, Bolt_H, lc}; //1
Point(20) = { -Holder_R_2, 0, Bolt_H, lc};
Point(21) = { -Holder_R_3, 0, Bolt_H, lc};

Point(22) = { -Holder_R_3, Holder_R_3, Bolt_H, lc};
Point(23) = { 0, 0, Bolt_H, lc};


Point(24) = { Holder_R_1, 0, Bolt_L-Bolt_H, lc}; // +11
Point(25) = { Holder_R_2, 0, Bolt_L-Bolt_H, lc};
Point(26) = { Holder_R_3, 0, Bolt_L-Bolt_H, lc};

Point(27) = { 0, Holder_R_1, Bolt_L-Bolt_H, lc};
Point(28) = { 0, Holder_R_2, Bolt_L-Bolt_H, lc};
Point(29) = { 0, Holder_R_3, Bolt_L-Bolt_H, lc};

Point(30) = { -Holder_R_1, 0, Bolt_L-Bolt_H, lc}; //1
Point(31) = { -Holder_R_2, 0, Bolt_L-Bolt_H, lc};
Point(32) = { -Holder_R_3, 0, Bolt_L-Bolt_H, lc};

Point(33) = { -Holder_R_3, Holder_R_3, Bolt_L-Bolt_H, lc};
Point(34) = { 0, 0, Bolt_L-Bolt_H, lc};

Line(1) = {1, 2};
Line(2) = {2, 3};
Line(3) = {3, 4};
Line(4) = {4, 5};
Line(5) = {5, 6};
Line(6) = {6, 7};
Line(7) = {7, 8};
Line(8) = {8, 1};

Line(9) = {9, 10};
Line(10) = {10, 11};
Line(11) = {11, 12};
Line(12) = {12, 9};

Line(13) = {13, 14};
Circle(14) = {14, 23, 17};
Line(15) = {16, 17};
Circle(16) = {13, 23, 16};

Line(17) = {14, 15};
Circle(18) = {15, 23, 18};
Line(19) = {17, 18};

Circle(20) = {17, 23, 20};
Line(21) = {19, 20};
Circle(22) = {16, 23, 19};
Line(23) = {20, 21};
Line(24) = {18, 22};
Line(25) = {21, 22};


Line(26) = {24, 25}; //+13
Circle(27) = {25, 34, 28};
Line(28) = {27, 28};
Circle(29) = {24, 34, 27};

Line(30) = {25, 26};
Circle(31) = {26, 34, 29};
Line(32) = {28, 29};

Circle(33) = {28, 34, 31};
Line(34) = {30, 31};
Circle(35) = {27, 34, 30};
Line(36) = {31, 32};
Line(37) = {29, 33};
Line(38) = {32, 33};

Transfinite Line {1} = nBolt_L+1 Using Progression 1;
Transfinite Line {2,8} = nBolt_R_2+1 Using Progression 1;
Transfinite Line {3,7} = nBolt_H+1 Using Progression 1;
Transfinite Line {4,6} = nBolt_R_1+1 Using Progression 1;
Transfinite Line {5} = nBolt_l+1 Using Progression 1;
Line Loop(1) = {1, 2, 3, 4, 5, 6, 7, 8};
Plane Surface(1) = {1};
//Transfinite Surface {1};
Recombine Surface {1};

Transfinite Line {9,11} = nSpacer_H+1 Using Progression 1;
Transfinite Line {10,12} = nSpacer_R+1 Using Progression 1;
Line Loop(2) = {9, 10, 11, 12};
Plane Surface(2) = {2};
Transfinite Surface {2};
Recombine Surface {2};

Transfinite Line {13,15} = nHolder_R+1 Using Progression 1;
Transfinite Line {14,16} = nHolder_Theta+1 Using Progression 1;
Line Loop(3) = {13, 14, -15, -16};
Plane Surface(3) = {3};
Transfinite Surface {3};
Recombine Surface {3};

Transfinite Line {17,19} = nHolder_R+1 Using Progression 1;
Transfinite Line {18} = nHolder_Theta+1 Using Progression 1;
Line Loop(4) = {17, 18, -19, -14};
Plane Surface(4) = {4};
Transfinite Surface {4};
Recombine Surface {4};

Transfinite Line {21} = nHolder_R+1 Using Progression 1;
Transfinite Line {20,22} = nHolder_Theta+1 Using Progression 1;
Line Loop(5) = {15, 20, -21, -22};
Plane Surface(5) = {5};
Transfinite Surface {5};
Recombine Surface {5};

Transfinite Line {23} = nHolder_R+1 Using Progression 1;
Transfinite Line {24,25} = nHolder_R+nHolder_G+1 Using Progression 1;
Line Loop(6) = {19, 24, -25, -23,-20};
Plane Surface(6) = {6};
Recombine Surface {6};



Transfinite Line {26,28} = nHolder_R+1 Using Progression 1;
Transfinite Line {27,29} = nHolder_Theta+1 Using Progression 1;
Line Loop(7) = {26, 27, -28, -29};
Plane Surface(7) = {7};
Transfinite Surface {7};
Recombine Surface {7};

Transfinite Line {30,32} = nHolder_R+1 Using Progression 1;
Transfinite Line {31} = nHolder_Theta+1 Using Progression 1;
Line Loop(8) = {30, 31, -32, -27};
Plane Surface(8) = {8};
Transfinite Surface {8};
Recombine Surface {8};

Transfinite Line {34} = nHolder_R+1 Using Progression 1;
Transfinite Line {33,35} = nHolder_Theta+1 Using Progression 1;
Line Loop(9) = {28, 33, -34, -35};
Plane Surface(9) = {9};
Transfinite Surface {9};
Recombine Surface {9};

Transfinite Line {36} = nHolder_R+1 Using Progression 1;
Transfinite Line {37,38} = nHolder_R+nHolder_G+1 Using Progression 1;
Line Loop(10) = {32, 37, -38, -36,-33};
Plane Surface(10) = {10};
Recombine Surface {10};



Extrude {{0, 0, 1}, {0, 0, 0}, Pi} {
  Surface{1};  Layers{2*nBolt_Theta}; Recombine;
}

Extrude {{0, 0, 1}, {0, 0, 0}, Pi} {
  Surface{2}; Layers{2*nSpacer_Theta}; Recombine;
}


Extrude {0, 0, Holder_H}
{
  Surface{3,4,5,6}; Layers{nHolder_H}; Recombine;
}

Extrude {0, 0, -Holder_H}
{
  Surface{7,8,9,10}; Layers{nHolder_H}; Recombine;
}

Physical Volume("Bolt") = {1};
Physical Volume("Spacer") = {2};
Physical Volume("Holder 1") = {7, 8, 9, 10};
Physical Volume("Holder 2") = {3, 4, 5, 6};
Physical Surface("Sym y") = {283, 256, 80, 1, 204, 226, 2, 111, 133, 102, 163, 190};
Physical Surface("Bolt to Holder 1") = {63};
Physical Surface("Bolt to Holder 2") = {71};
Physical Surface("Spacer to Holder 1") = {93};
Physical Surface("Spacer to Holder 2") = {101};
Physical Surface("Holder 1 to Bolt") = {7, 9};
Physical Surface("Holder 1 to Spacer") = {261, 217};
Physical Surface("Holder 2 to Bolt") = {3, 5};
Physical Surface("Holder 2 to Spacer") = {124, 168};
Physical Surface("Holder 2 end") = {186};
Physical Surface("Holder 1 end") = {279};
