// $Id$
// fichier de donnees gmsh

gap = 0.;

Spacer_R_1 = 7.5;
Spacer_R_2 = 20;
Spacer_H = 10;

Holder_H = 10;
Holder_R_1 = 6;
Holder_R_2 = 15;
Holder_R_3 = 30;

Bolt_R_0 = 2;
Bolt_R_1 = 5;
Bolt_R_2 = 10;
Bolt_H = 5;

Bolt_L = 2*Bolt_H+2*Holder_H+Spacer_H;

nSpacer_R = 5;
nSpacer_H = 5;
nSpacer_Theta = 6; // for a quarter of the spacer (Pi/2)

nHolder_R = 5;
nHolder_H = 5;
nHolder_Theta = 6;
nHolder_G = 3;

nBolt_R_1 = 4;
nBolt_R_2 = 8;
nBolt_H = 4;
nBolt_l = 20;
nBolt_L = nBolt_l + 2*nBolt_H;
nBolt_Theta = 6;

lc = 1;

Point(1) = { Bolt_R_0,   0, 0, lc};
Point(2) = { Bolt_R_0,   0, Bolt_L, lc};
Point(3) = { Bolt_R_2, 0, Bolt_L, lc};
Point(4) = { Bolt_R_2, 0, Bolt_L-Bolt_H+gap, lc};
Point(5) = { Bolt_R_1, 0, Bolt_L-Bolt_H+gap, lc};
Point(6) = { Bolt_R_1, 0, Bolt_H-gap, lc};
Point(7) = { Bolt_R_2, 0, Bolt_H-gap, lc};
Point(8) = { Bolt_R_2, 0, 0, lc};

Point(9) = { Spacer_R_1, 0, Bolt_H+Holder_H+gap, lc};
Point(10) = { Spacer_R_1, 0, Bolt_L-Bolt_H-Holder_H-gap, lc};
Point(11) = { Spacer_R_2, 0, Bolt_L-Bolt_H-Holder_H-gap, lc};
Point(12) = { Spacer_R_2, 0, Bolt_H+Holder_H+gap, lc};


Point(13) = { Holder_R_1, 0, Bolt_H, lc};
Point(14) = { Holder_R_1, 0, Bolt_H+Holder_H, lc};
Point(15) = { Holder_R_2, 0, Bolt_H+Holder_H, lc};
Point(16) = { Holder_R_2, 0, Bolt_H, lc};

Point(17) = { Holder_R_1, 0, Bolt_L-Bolt_H, lc};
Point(18) = { Holder_R_1, 0, Bolt_L-Bolt_H-Holder_H, lc};
Point(19) = { Holder_R_2, 0, Bolt_L-Bolt_H-Holder_H, lc};
Point(20) = { Holder_R_2, 0, Bolt_L-Bolt_H, lc};

Point(21) = { 0, Holder_R_3, Bolt_H, lc};
Point(22) = { 0, Holder_R_2, Bolt_H, lc};
Point(23) = { -Holder_R_2, 0, Bolt_H, lc};
Point(24) = { -Holder_R_3, 0, Bolt_H, lc};
Point(25) = { -Holder_R_3, Holder_R_3, Bolt_H, lc};
Point(26) = { 0,0, Bolt_H, lc};

Point(27) = { 0, Holder_R_3, Bolt_L-Bolt_H-Holder_H, lc};
Point(28) = { 0, Holder_R_2, Bolt_L-Bolt_H-Holder_H, lc};
Point(29) = { -Holder_R_2, 0, Bolt_L-Bolt_H-Holder_H, lc};
Point(30) = { -Holder_R_3, 0, Bolt_L-Bolt_H-Holder_H, lc};
Point(31) = { -Holder_R_3, Holder_R_3, Bolt_L-Bolt_H-Holder_H, lc};
Point(32) = { 0,0, Bolt_L-Bolt_H-Holder_H, lc};

Point(33) = { Holder_R_2, 0, Bolt_H, lc};
Point(34) = { Holder_R_2, 0, Bolt_H+Holder_H, lc};
Point(35) = { Holder_R_3, 0, Bolt_H+Holder_H, lc};
Point(36) = { Holder_R_3, 0, Bolt_H, lc};

Point(37) = { Holder_R_2, 0, Bolt_L-Bolt_H, lc};
Point(38) = { Holder_R_2, 0, Bolt_L-Bolt_H-Holder_H, lc};
Point(39) = { Holder_R_3, 0, Bolt_L-Bolt_H-Holder_H, lc};
Point(40) = { Holder_R_3, 0, Bolt_L-Bolt_H, lc};

Line(1) = {1, 2};
Line(2) = {2, 3};
Line(3) = {3, 4};
Line(4) = {4, 5};
Line(5) = {5, 6};
Line(6) = {6, 7};
Line(7) = {7, 8};
Line(8) = {8, 1};

Line(9) = {9, 10};
Line(10) = {10, 11};
Line(11) = {11, 12};
Line(12) = {12, 9};

Line(13) = {13, 14};
Line(14) = {14, 15};
Line(15) = {15, 16};
Line(16) = {16, 13};

Line(17) = {17, 18};
Line(18) = {18, 19};
Line(19) = {19, 20};
Line(20) = {20, 17};

Line(21) = {21, 22};
Circle(22) = {22, 26, 23};
Line(23) = {23, 24};
Line(24) = {24, 25};
Line(25) = {25, 21};

Line(26) = {27, 28};
Circle(27) = {28, 32, 29};
Line(28) = {29, 30};
Line(29) = {30, 31};
Line(30) = {31, 27};

Line(31) = {33, 34};
Line(32) = {34, 35};
Line(33) = {35, 36};
Line(34) = {36, 33};

Line(35) = {37, 38};
Line(36) = {38, 39};
Line(37) = {39, 40};
Line(38) = {40, 37};

Transfinite Line {1} = nBolt_L+1 Using Progression 1;
Transfinite Line {2,8} = nBolt_R_2+1 Using Progression 1;
Transfinite Line {3,7} = nBolt_H+1 Using Progression 1;
Transfinite Line {4,6} = nBolt_R_1+1 Using Progression 1;
Transfinite Line {5} = nBolt_l+1 Using Progression 1;
Line Loop(1) = {1, 2, 3, 4, 5, 6, 7, 8};
Plane Surface(1) = {1};
//Transfinite Surface {1};
Recombine Surface {1};

Transfinite Line {9,11} = nSpacer_H+1 Using Progression 1;
Transfinite Line {10,12} = nSpacer_R+1 Using Progression 1;
Line Loop(2) = {9, 10, 11, 12};
Plane Surface(2) = {2};
Transfinite Surface {2};
Recombine Surface {2};

Transfinite Line {13,15} = nHolder_H+1 Using Progression 1;
Transfinite Line {14,16} = nHolder_R+1 Using Progression 1;
Line Loop(3) = {13, 14, 15, 16};
Plane Surface(3) = {3};
Transfinite Surface {3};
Recombine Surface {3};

Transfinite Line {17,19} = nHolder_H+1 Using Progression 1;
Transfinite Line {18,20} = nHolder_R+1 Using Progression 1;
Line Loop(4) = {17, 18, 19, 20};
Plane Surface(4) = {4};
Transfinite Surface {4};
Recombine Surface {4};

Transfinite Line {21,23} = nHolder_R+1 Using Progression 1;
Transfinite Line {24,25} = nHolder_R+nHolder_G+1 Using Progression 1;
Transfinite Line {22} = nHolder_Theta+1 Using Progression 1;
Line Loop(5) = {21, 22, 23, 24, 25};
Plane Surface(5) = {5};
//Transfinite Surface {5};
Recombine Surface {5};

Transfinite Line {26,28} = nHolder_R+1 Using Progression 1;
Transfinite Line {29,30} = nHolder_R+nHolder_G+1 Using Progression 1;
Transfinite Line {27} = nHolder_Theta+1 Using Progression 1;
Line Loop(6) = {26, 27, 28, 29, 30};
Plane Surface(6) = {6};
//Transfinite Surface {6};
Recombine Surface {6};

Transfinite Line {31,33} = nHolder_H+1 Using Progression 1;
Transfinite Line {32,34} = nHolder_R+1 Using Progression 1;
Line Loop(7) = {31, 32, 33, 34};
Plane Surface(7) = {7};
Transfinite Surface {7};
Recombine Surface {7};

Transfinite Line {35,37} = nHolder_H+1 Using Progression 1;
Transfinite Line {36,38} = nHolder_R+1 Using Progression 1;
Line Loop(8) = {35, 36, 37, 38};
Plane Surface(8) = {8};
Transfinite Surface {8};
Recombine Surface {8};

Extrude {{0, 0, 1}, {0, 0, 0}, Pi} {
  Surface{1};  Layers{2*nBolt_Theta}; Recombine;
}

Extrude {{0, 0, 1}, {0, 0, 0}, Pi} {
  Surface{2}; Layers{2*nSpacer_Theta}; Recombine;
}

Extrude {{0, 0, 1}, {0, 0, 0}, Pi} {
  Surface{3}; Layers{2*nHolder_Theta}; Recombine;
}

Extrude {{0, 0, 1}, {0, 0, 0}, Pi} {
  Surface{4}; Layers{2*nHolder_Theta}; Recombine;
}

Extrude {0, 0, Holder_H}
{
  Surface{5}; Layers{nHolder_H}; Recombine;
}

Extrude {0, 0, Holder_H}
{
  Surface{6}; Layers{nHolder_H}; Recombine;
}

Extrude {{0, 0, 1}, {0, 0, 0}, Pi/2} {
  Surface{7}; Layers{nHolder_Theta}; Recombine;
}

Extrude {{0, 0, 1}, {0, 0, 0}, Pi/2} {
  Surface{8}; Layers{nHolder_Theta}; Recombine;
}


Physical Volume("Holder 1") = {6, 4,8};
Physical Volume("Holder 2") = {5, 3,7};
Physical Volume("Bolt") = {1};
Physical Volume("Spacer") = {2};
Physical Surface("Sym y") = { 94, 72, 1, 3, 2, 4,146, 191,124, 164,8,7,80,102};
Physical Surface("Spacer to Holder 1") = {93};
Physical Surface("Spacer to Holder 2") = {101};
Physical Surface("Holder 1 end") = {195};
Physical Surface("Holder 2 end") = {168};
Physical Surface("Bolt to Holder 1") = {63};
Physical Surface("Bolt to Holder 2") = {71};
Physical Surface("Holder 1 to Bolt") = {145};
Physical Surface("Holder 1 to Spacer") = {137};
Physical Surface("Holder 2 to Spacer") = {115};
Physical Surface("Holder 2 to Bolt") = {123};

Geometry.Tolerance = 1e-3; // adjust value here for correct merge result
Coherence Mesh;
