// $Id$
// fichier de donnees gmsh


//X=250m
//Y=250m
//Z=250m

L_1 = 250;
L_2 = 250;
L_3 = 0;
L_4 = 50;
H_1 = 50;
H_2 = 25;
H_3 = 25;
W = 50;


nL_1 = 20; //31
nL_2 = 20; //31
nL_4 = 5; //31
nH_1 = 5; //21
nH_2 = 3; //11
nH_3 = 9; //11
nW = 4; //25
nW2 = 8;

lc = 1;

Point(1) = { 0,   0, 0, lc};
Point(2) = { 0,   0, H_1, lc};
Point(3) = { L_2, 0, 0, lc};
Point(4) = { L_2, 0, H_1, lc};
Point(5) = { L_2, 0, H_1+H_2, lc};
Point(6) = { L_1+L_2, 0, 0, lc};
Point(7) = { L_1+L_2, 0, H_1, lc};
Point(8) = { L_1+L_2, 0, H_1+H_2, lc};
Point(9) = { -L_3,   0, -H_3, lc};
Point(10) = { -L_3,   0, H_1+H_2, lc};
Point(11) = { -L_3-L_4,   0, H_1+H_2, lc};
Point(12) = { -L_3-L_4,   0, -H_3, lc};


Line(1) = {2, 1};
Line(2) = {1, 3};
Line(3) = {4, 2};
Line(4) = {3, 4};
Line(5) = {4, 5};
Line(6) = {3, 6};
Line(7) = {7, 4};
Line(8) = {5, 8};
Line(9) = {6, 7};
Line(10) = {8, 7};
Line(11) = {9, 10};
Line(12) = {10, 11};
Line(13) = {11, 12};
Line(14) = {12, 9};

Transfinite Line {6,7,8} = nL_1 Using Progression 1;
Transfinite Line {2,3} = nL_2 Using Progression 1;
Transfinite Line {12,14} = nL_4 Using Progression 1;
Transfinite Line {1,4,9} = nH_1 Using Progression 1;
Transfinite Line {5,10} = nH_2 Using Progression 1;
Transfinite Line {11,13} = nH_3 Using Progression 1;

Line Loop(11) = {2, 4, 3, 1};
Plane Surface(12) = {11};
Transfinite Surface {12};
Recombine Surface {12};

Line Loop(13) = {6,9,7,-4};
Plane Surface(14) = {13};
Transfinite Surface {14};
Recombine Surface {14};

Line Loop(15) = {7, 10, 8, 5};
Plane Surface(16) = {15};
Transfinite Surface {16};
Recombine Surface {16};

Line Loop(17) = {11, 12, 13, 14};
Plane Surface(18) = {17};
Transfinite Surface {18};
Recombine Surface {18};


Extrude {0, -W, 0}
{
  Surface{12}; Layers{nW}; Recombine;
}

Extrude {0, -W, 0}
{
  Surface{14}; Layers{nW}; Recombine;
}

Extrude {0, -W, 0}
{
  Surface{16}; Layers{nW}; Recombine;
}

Extrude {0, -W-2*H_3, 0}
{
  Surface{18}; Layers{nW2}; Recombine;
}

// physical entities

Physical Line("Vertical clamped line") = {1};
Physical Line("Horizontal clamped line") = {23};
Physical Surface("Clamped Side") = {37};
Physical Surface("Mirror Side") = {79};
Physical Surface("Contact") = {55};
Physical Volume("Holder") = {1, 2};
Physical Volume("Mirror") = {3};
Physical Volume("Holder 2") = {4};
Physical Surface("Holder 2 front") = {93};
Physical Surface("Holder 2 back") = {101};
Physical Surface("Holder front") = {53};
Physical Surface("Holder back") = {39};
Physical Surface("Holder below") = {27,49};
Physical Surface("y sym") = {12,14,16,18};
// Physical Surface("z sym") = {27,49,105};
