#ifndef WELEMENTMATRICES_H
#define WELEMENTMATRICES_H

#include "Stokhos_Sacado_Kokkos_MP_Vector.hpp"
#include "EnsembleTraits.h"

/*
#include "Stokhos_Tpetra_MP_Vector.hpp"
#include "Stokhos_Tpetra_Utilities_MP_Vector.hpp"
#include "Stokhos_Sacado_Kokkos_MP_Vector.hpp"
*/

#include <Kokkos_Core.hpp>
#include "Kokkos_ViewFactory.hpp"
#include "wCacheHex8.h"
#include "wCacheQuad4.h"
#include "wCacheTetra4.h"
#include "wCacheTri3.h"
#include "tMatrix.h"

//#include "Sacado_Fad_MP_Vector.hpp"
//#include "Sacado.hpp"
#include "Domain.h"

#include "Materials_list.h"
#include "Material.h"

#include "wLazy.h"
#include "tMatrix.h"

#include "ElementComputation.h"

#include "EnsembleTraits.h"

#include <iostream>

template<typename scalar, int element_type, int element_size> class ElementMatrices : public ElementComputation<scalar,element_type>
{
public:
    Kokkos::View<scalar***, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> K;
    Kokkos::View<scalar***, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> L;
    Kokkos::View<scalar***, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> S;

    Kokkos::View<scalar***, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> K_e;
    Kokkos::View<scalar***, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> L_e;
    Kokkos::View<scalar***, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> S_e;

    Kokkos::View<scalar**, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> material;

    Teuchos::RCP<mrstlnos::discrete_problem::Domain<scalar>> domain;

    size_t numPrimalDPN;

    ElementMatrices(){};
    ElementMatrices(Teuchos::RCP<mrstlnos::discrete_problem::Domain<scalar>> domain, size_t numPrimalDPN, size_t pool_size );
    //ElementMatrices(local_ordinal_type e, mrstlnos::discrete_problem::Domain<scalar> domain, size_t numPrimalDPN);

    void compute(int e,  int i_thread);

    Kokkos::View<scalar**, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> getK(size_t i_thread) const
    {
        Kokkos::View<scalar**, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> K_current = subview (K, i_thread, Kokkos::ALL(), Kokkos::ALL());
        return  K_current;
    };
    Kokkos::View<scalar**, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> getL(size_t i_thread) const
    {
        Kokkos::View<scalar**, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> L_current = subview (L, i_thread, Kokkos::ALL(), Kokkos::ALL());
        return  L_current;
    };
    Kokkos::View<scalar**, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> getS(size_t i_thread) const
    {
        Kokkos::View<scalar**, Kokkos::LayoutRight,Kokkos::DefaultExecutionSpace> S_current = subview (S, i_thread, Kokkos::ALL(), Kokkos::ALL());
        return  S_current;
    };
};


//template<typename scalar, int element_type, int element_size> void ElementMatrices<scalar, element_type, element_size>::compute(local_ordinal_type e, size_t i_thread);


#endif //WELEMENTMATRICES_H
