#ifndef WGRAPH_H
#define WGRAPH_H

#include "mrstlnos.h"

#include "Map.h"
#include "Elements_list.h"

#include <Tpetra_Map.hpp>
#include <Tpetra_Vector.hpp>
#include <Tpetra_CrsGraph.hpp>

#include <Teuchos_RCP.hpp>

using Teuchos::RCP;

typedef Tpetra::Vector<>::local_ordinal_type local_ordinal_type;
typedef Tpetra::Vector<>::global_ordinal_type global_ordinal_type;
typedef Tpetra::CrsGraph<local_ordinal_type,global_ordinal_type> crs_graph_type;

namespace mrstlnos
{
    namespace discrete_problem
    {
        class Graph
        {
        public:
            RCP<crs_graph_type> AWO;
            RCP<crs_graph_type> A;

            Graph();
            Graph(Teuchos::RCP<Map> map, Teuchos::RCP<Elements_list> elements_list);
        };
    };
};

#endif //WGRAPH_H
