#ifndef WITERATIVESOLVER_H
#define WITERATIVESOLVER_H

#include "mrstlnos.h"
#include "wObject.h"
#include "wTimer.h"
#include "wTimers.h"
#include "Teuchos_ParameterList.hpp"

#include "LinearSolver.h"

namespace mrstlnos {

class MRSTLNOS_API IterativeSolver : public LinearSolver
{
public:
    IterativeSolver(Problem &pbl, int nthreads, Teuchos::RCP<Teuchos::ParameterList> solverList,int numPrimalDPN=3, bool ensemble_propagation=false, size_t minimum_ensemble_size =1, bool signorini=false)
    :LinearSolver(pbl, nthreads, solverList, numPrimalDPN, ensemble_propagation, minimum_ensemble_size, signorini)
    {
    };
#ifndef SWIG
    virtual void write(std::ostream &out) const;
#endif
    void start();
private:    
    template<typename scalar> void tstart();

};

}

#endif //WSOLVER_H
