#ifndef MUELU_INTERFACEMAPPINGTRANSFERTFACTORY_DEF_HPP_
#define MUELU_INTERFACEMAPPINGTRANSFERTFACTORY_DEF_HPP_

#include <Xpetra_Map_fwd.hpp>
#include <Xpetra_MapFactory_fwd.hpp>
#include <Xpetra_Matrix_fwd.hpp>

#include "MueLu_Level.hpp"
#include "MueLu_FactoryManagerBase.hpp"
#include "MueLu_Monitor.hpp"

namespace MueLu {

    template <class Scalar = double,
    class LocalOrdinal = int,
    class GlobalOrdinal = LocalOrdinal,
    class Node = KokkosClassic::DefaultNode::DefaultNodeType>
    class InterfaceMappingTransferFactory : public TwoLevelFactoryBase {

    public:
    #undef MUELU_INTERFACEMAPPINGTRANSFERTFACTORY_SHORT
    #include "MueLu_UseShortNamesOrdinal.hpp"

    //! Constructor.
    InterfaceMappingTransferFactory();
    
    //! Destructor.
    virtual ~InterfaceMappingTransferFactory() {}

    RCP<const ParameterList> GetValidParameterList() const;
    void DeclareInput(Level& fineLevel, Level& coarseLevel) const;
    void Build(Level& fineLevel, Level& coarseLevel) const;
}; 

}
#define MUELU_INTERFACEMAPPINGTRANSFERTFACTORY_SHORT
#endif /* MUELU_INTERFACEMAPPINGTRANSFERTFACTORY_DEF_HPP_ */