#ifndef MUELU_INTERFACEMAPPINGTRANSFERTFACTORY_DECL_HPP_
#define MUELU_INTERFACEMAPPINGTRANSFERTFACTORY_DECL_HPP_

#include "MueLu_InterfaceMappingTransferFactory_decl.hpp"

#include <Xpetra_Map.hpp>
#include <Xpetra_MapFactory.hpp>
#include <Xpetra_Matrix.hpp>

#include "MueLu_Level.hpp"
#include "MueLu_FactoryManagerBase.hpp"
#include "MueLu_Monitor.hpp"

namespace MueLu {

    template <class Scalar, class LocalOrdinal, class GlobalOrdinal, class Node>
    InterfaceMappingTransferFactory<Scalar, LocalOrdinal, GlobalOrdinal, Node>::InterfaceMappingTransferFactory()
    {
    }    

    template <class Scalar, class LocalOrdinal, class GlobalOrdinal, class Node>
    RCP<const ParameterList> InterfaceMappingTransferFactory<Scalar, LocalOrdinal, GlobalOrdinal, Node>::GetValidParameterList() const {
        RCP<ParameterList> validParamList = rcp(new ParameterList());
        return validParamList;
    }

    template <class Scalar, class LocalOrdinal, class GlobalOrdinal, class Node>
    void InterfaceMappingTransferFactory<Scalar, LocalOrdinal, GlobalOrdinal, Node>::DeclareInput(Level& fineLevel, Level& coarseLevel) const {
        fineLevel.DeclareInput("CoarseLagr2Dof", NoFactory::get(), this);
    }

    template <class Scalar, class LocalOrdinal, class GlobalOrdinal, class Node>
    void InterfaceMappingTransferFactory<Scalar, LocalOrdinal, GlobalOrdinal, Node>::Build(Level& fineLevel, Level& coarseLevel) const {
        Monitor m(*this, "Interface Mapping transfer factory");
        RCP<std::map<GlobalOrdinal,GlobalOrdinal> > coarseLagr2Dof = fineLevel.Get<RCP<std::map<GlobalOrdinal, GlobalOrdinal> > >("CoarseLagr2Dof", NoFactory::get());
        coarseLevel.Set<RCP<std::map<GlobalOrdinal,GlobalOrdinal> > >("Lagr2Dof", coarseLagr2Dof, NoFactory::get());
    }

}

#endif /* MUELU_INTERFACEMAPPINGTRANSFERTFACTORY_DECL_HPP_ */