#include"Nodes_list.h"

#include "wProblem.h"
#include "wMshData.h"
#include "wNode.h"

using namespace mrstlnos;
using namespace discrete_problem;

Nodes_list::Nodes_list()
{
    nodes_number = 0;

    nodes = Kokkos::View<double**, Kokkos::LayoutRight> ("R",nodes_number,0);
}

Nodes_list::Nodes_list(Problem &pbl, Teuchos::RCP<Map> map)
{
    typedef Tpetra::Vector<>::local_ordinal_type local_ordinal_type;

    nodes_number = map->mapNodesWO->getNodeNumElements ();

    nodes = Kokkos::View<double**, Kokkos::LayoutRight> ("R",nodes_number,3);
    for (auto i = 0; i < nodes_number; ++i)
        for( auto j=0; j<3; ++j)
            nodes(i,j) = pbl.msh->nodes[map->mapNodesWO->getGlobalElement(i)]->pos.x[j];
}
