#ifndef WMEDIUM_H
#define WMEDIUM_H

#include "mrstlnos.h"
#include "wGroup.h"
#include <string>
#include <vector>

using namespace tbox;

namespace mrstlnos {

/**
 * @brief a thermomechanical medium : in progress
 */

class MRSTLNOS_API Medium : public Group
{
public:
    std::string medium_name;
    double E;
    std::vector<double> E_vector;
    std::vector<double> nu_vector;
    double nu;
    double k;
    double beta;
    Medium(Problem &pbl, int no, std::string _medium_name, std::vector<double> _E, std::vector<double> _nu, double _k=0., double _beta=0.);
    Medium(Problem &pbl, std::string const &name, std::string _medium_name, std::vector<double> _E, std::vector<double> _nu, double _k=0., double _beta=0.);

#ifndef SWIG
    virtual void write(std::ostream &out) const;
#endif
};

}

#endif //WMEDIUM_H
