#ifndef WNEUMANN_H
#define WNEUMANN_H

#include "mrstlnos.h"
#include "wGroup.h"
#include "wPt.h"
#include <vector>
#include <string>
using namespace tbox;

namespace mrstlnos {

/**
 * @brief manage mechanical Dirichlet BC
 */

class MRSTLNOS_API Neumann : public Group
{
public:
    std::string const &BC_name;
    std::vector<Node *> nodes;
    std::vector<int> which_dof;
    std::vector<double> values;

    //uDirichlet(Problem &pbl, int no, std::string const &_BC_name, std::vector<int> const &_which_dof, std::vector<double> const &_values);
    Neumann(Problem &pbl, std::string const &name, std::string const &_BC_name, std::vector<int> _which_dof, std::vector<double> _values);

    Neumann(Problem &pbl, std::string const &name, std::string const &_BC_name, int x, std::vector<double> v_x, int y, std::vector<double> v_y, int z, std::vector<double> v_z, int T , std::vector<double> v_T , size_t ensemble_size);

#ifndef SWIG
    virtual void write(std::ostream &out) const;
#endif
};

}

#endif //WNEUMANN_H
