#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright 2020 University of Liège
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


import numpy as np
import params.src.indices as indices
from numpy.polynomial import Polynomial, Legendre

def phi(xi,N,n_max,d):

    N_max = max(N)

    L = np.zeros((d,N_max))
    for j in range(0,d):
        for i in range(0,N_max):
            L[j,i] = Legendre.basis(i)(xi[j])

    i =      np.zeros((d,), dtype =np.int)
    i_zero = np.zeros((d,), dtype =np.int)
    i_one =  np.ones((d,), dtype =np.int)
    p = 0


    phi = np.ones((n_max,))
    n_i = 0
    while np.all(i != -i_one):
        for j in range(0,d):
            phi[n_i] = phi[n_i]*L[j,i[j]] / np.sqrt(2./(2*i[j]+1))
        n_i = n_i + 1
        p,i = indices.next(p,i,N,d)
    return phi
