/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WCACHE_H
#define WCACHE_H

#include "tbox.h"
#include <vector>
#include "wGauss.h"

namespace tbox
{

/**
 * @brief Base cache for element
 * @authors Romain Boman, Adrien Crovato
 */
class TBOX_API Cache
{
public:
    int npg; // NOT the nb of gauss points for Tri3 and Tetra4!

    std::vector<std::vector<std::vector<double>>> dff;
    std::vector<std::vector<double>> ff;

    explicit Cache(int _npg);
    virtual ~Cache() {}

    virtual Gauss &getVGauss();
};

} // namespace tbox

#endif //WCACHE_H
