#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright 2020 University of Liège
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


# @brief VTK Reader
# @authors Adrien Crovato

try:
    import vtk
except:
    raise Exception('VTK not found. Aborting!\n')

class Reader:
    def __init__(self):
        self.reader = vtk.vtkXMLUnstructuredGridReader()

    def open(self, fname):
        import os.path
        extensions = ['.pvtu','.vtu','.vtk']
        extension = None
        for extension_tmp in extensions:
          if os.path.isfile(fname+extension_tmp):
            extension = extension_tmp
            break
        if extension is None: raise Exception("file %s.pvtu/.vtu/.vtk not found!\n" %fname)
        self.reader.SetFileName(fname+extension)
        self.reader.Update()

    def close(self):
        print 'No need to do that apparently...\n'
        #self.reader.CloseFile()
